/******/ (() => { // webpackBootstrap
/******/ 	"use strict";
/******/ 	var __webpack_modules__ = ({

/***/ "./src/address.ts":
/*!************************!*\
  !*** ./src/address.ts ***!
  \************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   Address: () => (/* binding */ Address)
/* harmony export */ });
/* harmony import */ var _common__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./common */ "./src/common.ts");

class Address {
    constructor(prefix, composite) {
        this.prefix = prefix;
        this.composite = composite;
        const suggestionId = `suggestions_${prefix}`;
        this.suggestions = $(`<div id="${suggestionId}" style="display:none;"></div>`);
        $(`#${composite}`).after(this.suggestions);
        $(`#${composite}`).on('input', (event) => this.onInput(event));
        $(`#${composite}`).attr("placeholder", "Start typing address...");
    }
    onInput(event) {
        const postalCode = event.target.value;
        if (postalCode.length >= 6) {
            this.getSuggestions(postalCode);
        }
        else {
            this.suggestions.hide();
        }
    }
    getSuggestions(query) {
        shell.ajaxSafePost({
            contentType: "application/json",
            type: "POST",
            url: '/_api/cloudflow/v1.0/trigger/20bac6ff-7d67-ef11-a671-6045bd0c9b65',
            data: JSON.stringify({ "eventData": JSON.stringify({ "Address": query, "Limit": 5 }) }),
            processData: false,
            global: false
        })
            .done((response) => {
            var _a;
            const data = JSON.parse(response);
            if (data && data.results) {
                const parsedResults = JSON.parse(data.results);
                if (((_a = parsedResults === null || parsedResults === void 0 ? void 0 : parsedResults.results) === null || _a === void 0 ? void 0 : _a.length) > 0) {
                    this.showSuggestions(parsedResults.results);
                }
                else {
                    this.suggestions.hide();
                }
            }
            else {
                this.suggestions.hide();
            }
        });
    }
    showSuggestions(suggestions) {
        let suggestionHTML = '<ul style="list-style: none; padding: 0; background: white; border: 1px solid #ccc;">';
        suggestions.forEach(suggestion => {
            const formattedAddress = suggestion.address.freeformAddress;
            const li = document.createElement('li');
            li.style.padding = '5px';
            li.style.cursor = 'pointer';
            li.dataset.address = JSON.stringify(suggestion.address);
            li.textContent = formattedAddress;
            suggestionHTML += li.outerHTML;
        });
        suggestionHTML += '</ul>';
        this.suggestions.html(suggestionHTML).show();
        // Attach click event dynamically
        this.suggestions.find("li").on("click", (event) => {
            const selectedAddress = JSON.parse($(event.currentTarget).attr("data-address"));
            this.selectAddress(selectedAddress);
        });
    }
    selectAddress(address) {
        var _a;
        $(`#${this.composite}`).val(address.freeformAddress);
        if ($(`#${this.prefix}_line1`).length > 0) {
            $(`#${this.prefix}_line1`).val(address.streetNumber ? `${address.streetNumber} ${address.streetName}` : address.streetName || '');
            $(`#${this.prefix}_line2`).val(address.municipalitySubdivision || '');
            $(`#${this.prefix}_city`).val(address.municipality || '');
            $(`#${this.prefix}_country`).val(address.country || '');
            $(`#${this.prefix}_postalcode`).val(((_a = address.extendedPostalCode) === null || _a === void 0 ? void 0 : _a.split(',')[0]) || '');
            $(`#${this.prefix}_stateorprovince`).val(address.countrySubdivisionName || '');
        }
        this.suggestions.hide();
    }
    static countryAsDropdown(fieldId) {
        var countryField = $('#' + fieldId);
        var storedValue = countryField.val();
        var countryDropdown = $('<select class="form-control form-select picklist  dirty"></select>').attr('id', countryField.attr('id')).attr('name', countryField.attr('name'));
        $.each(_common__WEBPACK_IMPORTED_MODULE_0__.Common.countries, function (index, value) {
            var option = $('<option></option>').val(value).text(value);
            if (value === storedValue) {
                option.attr('selected', 'selected');
            }
            countryDropdown.append(option);
        });
        countryField.replaceWith(countryDropdown);
    }
    static validatePostcode(prefix, modal = false, basicForm = false) {
        var _a;
        const country = $(`#${prefix}_country`).val();
        const postcodeField = $(`#${prefix}_postalcode`);
        let postcode = String((_a = postcodeField.val()) !== null && _a !== void 0 ? _a : "").trim().toUpperCase();
        if (country !== "United Kingdom")
            return true;
        if (postcode && !postcode.includes(" ") && postcode.length > 4) {
            postcode = postcode.slice(0, -3) + " " + postcode.slice(-3);
        }
        postcodeField.val(postcode);
        const valid = /^([A-Z]{1,2}[0-9][A-Z0-9]? [0-9][A-Z]{2})$/i.test(postcode);
        if (!valid) {
            _common__WEBPACK_IMPORTED_MODULE_0__.Common.showMessage("Invalid UK Post Code format", "danger", false, modal, basicForm);
        }
        return valid;
    }
}


/***/ }),

/***/ "./src/administration.ts":
/*!*******************************!*\
  !*** ./src/administration.ts ***!
  \*******************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   Administration: () => (/* binding */ Administration)
/* harmony export */ });
/* harmony import */ var _common__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./common */ "./src/common.ts");

class Administration {
    static initializeAdministrationScreen() {
        _common__WEBPACK_IMPORTED_MODULE_0__.Common.hideAllOfClass("entitylist");
        _common__WEBPACK_IMPORTED_MODULE_0__.Common.addShowSectionBtnListener('accountsbtn', 'accountsentitylist', 'entitylist');
        _common__WEBPACK_IMPORTED_MODULE_0__.Common.addShowSectionBtnListener('branchesbtn', 'branchesentitylist', 'entitylist');
        _common__WEBPACK_IMPORTED_MODULE_0__.Common.addShowSectionBtnListener('contactsbtn', 'contactsentitylist', 'entitylist');
    }
    static referrerEditFormLogic() {
        _common__WEBPACK_IMPORTED_MODULE_0__.Common.setValidator("frv_bankaccountname", true);
        _common__WEBPACK_IMPORTED_MODULE_0__.Common.setValidator("frv_bankaccountnumber", true);
        _common__WEBPACK_IMPORTED_MODULE_0__.Common.setValidator("frv_sortcode", true);
        _common__WEBPACK_IMPORTED_MODULE_0__.Common.setValidator("frv_vatregistered", true);
        _common__WEBPACK_IMPORTED_MODULE_0__.Common.setValidator("telephone1", true);
        _common__WEBPACK_IMPORTED_MODULE_0__.Common.setValidator("address1_stateorprovince", true);
        _common__WEBPACK_IMPORTED_MODULE_0__.Common.setValidator("address1_line1", true);
        _common__WEBPACK_IMPORTED_MODULE_0__.Common.setValidator("address1_city", true);
        _common__WEBPACK_IMPORTED_MODULE_0__.Common.setValidator("address1_postalcode", true);
        _common__WEBPACK_IMPORTED_MODULE_0__.Common.setValidator("address1_country", true);
        _common__WEBPACK_IMPORTED_MODULE_0__.Common.setValidator("address2_stateorprovince", true);
        _common__WEBPACK_IMPORTED_MODULE_0__.Common.setValidator("address2_line1", true);
        _common__WEBPACK_IMPORTED_MODULE_0__.Common.setValidator("address2_city", true);
        _common__WEBPACK_IMPORTED_MODULE_0__.Common.setValidator("address2_postalcode", true);
        _common__WEBPACK_IMPORTED_MODULE_0__.Common.setValidator('address2_country', true);
        _common__WEBPACK_IMPORTED_MODULE_0__.Common.toggleVisibility("accountcategorycode", false, 1);
        const vatRegisteredField = $("#frv_vatregistered");
        vatRegisteredField.on('change', () => Administration.toggleVatNumberRequirement(vatRegisteredField));
        vatRegisteredField.trigger('change');
    }
    static referrerBranchEditFormLogic() {
        $('#parentaccountid').siblings("button").prop("disabled", true).hide();
        _common__WEBPACK_IMPORTED_MODULE_0__.Common.toggleVisibility("parentaccountid", false);
        _common__WEBPACK_IMPORTED_MODULE_0__.Common.toggleVisibility("accountcategorycode", false);
    }
    static salesRepresentativeCreateFormLogic() {
        $('#parentcustomerid').siblings("button").prop("disabled", true).hide();
    }
    static salesRepresentativeEditFormLogic() {
        $('#parentcustomerid').siblings("button").prop("disabled", true).hide();
    }
    static salesRepresentativeSendInviteLogic() {
        _common__WEBPACK_IMPORTED_MODULE_0__.Common.toggleVisibility("frv_sendinvitation", false);
        _common__WEBPACK_IMPORTED_MODULE_0__.Common.toggleVisibility("frv_lastinvitationdate", false);
    }
    static toggleVatNumberRequirement(vatRegisteredField) {
        _common__WEBPACK_IMPORTED_MODULE_0__.Common.setValidator("frv_vatnumber", vatRegisteredField.val() === "100000001");
    }
    static toggleBtnSelection(selectedId) {
        // Define an array of valid button IDs
        const validButtonIds = ['accountsbtn', 'branchesbtn', 'contactsbtn'];
        // Ensure the selectedId is in the valid list
        if (!validButtonIds.includes(selectedId))
            return;
        // Get all target buttons by their IDs
        const buttons = validButtonIds.map(id => document.querySelector(`#${id} a`));
        // Remove the selected style from all buttons
        buttons.forEach(button => {
            if (button) {
                button.style.backgroundColor = '';
                button.style.borderColor = 'transparent';
                button.style.boxShadow = 'none';
                button.style.fontWeight = 'normal';
                //button.style.padding = '10px 25px'; // Reset padding
                button.style.transform = 'none'; // Reset button position
            }
        });
        // Get the selected button
        const selectedButton = document.querySelector(`#${selectedId} a`);
        if (selectedButton) {
            // Apply a more noticeable "pressed" effect
            selectedButton.style.backgroundColor = '#002752'; // Darker background
            selectedButton.style.borderColor = '#001d40'; // Slightly darker border
            selectedButton.style.boxShadow = 'inset 4px 4px 8px rgba(0, 0, 0, 0.5)'; // Deeper inset shadow
            selectedButton.style.fontWeight = 'bold'; // Bold text
            //selectedButton.style.padding = '8px 23px'; // Reduce padding to make it look pressed
            selectedButton.style.transform = 'translateY(2px)'; // Slight downward movement to simulate press
        }
    }
}


/***/ }),

/***/ "./src/common.ts":
/*!***********************!*\
  !*** ./src/common.ts ***!
  \***********************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   Common: () => (/* binding */ Common)
/* harmony export */ });
class Common {
    static safeAjax(ajaxOptions) {
        return new Promise((resolve, reject) => {
            shell.getTokenDeferred()
                .done((token) => {
                if (!ajaxOptions.headers) {
                    ajaxOptions.headers = { "__RequestVerificationToken": token };
                }
                else {
                    ajaxOptions.headers["__RequestVerificationToken"] = token;
                }
                $.ajax(ajaxOptions)
                    .done((data, textStatus, jqXHR) => {
                    validateLoginSession(data, textStatus, jqXHR, resolve);
                })
                    .fail(reject);
            })
                .fail((...args) => {
                reject(args);
            });
        });
    }
    static showMessage(message, type, spinner = false, modal = false, basicForm = false) {
        var _a;
        let spinnerDiv = "";
        if (spinner) {
            spinnerDiv = `<div id="overlay"><div class="cv-spinner"><span class="spinner"></span></div></div>`;
        }
        let selector;
        if (basicForm) {
            selector = $('#EntityFormPanel');
        }
        else {
            selector = $('#WebFormPanel');
        }
        $('#ValidationSummaryEntityFormControl_EntityFormView').remove();
        if (modal) {
            selector = $('#UpdateButton');
            $(window.parent.document).find('#ValidationSummaryEntityFormControl_EntityFormView').remove();
        }
        $(selector).before(`<div id="ValidationSummaryEntityFormControl_EntityFormView" class="validation-summary alert alert-${type} alert-block" style="" tabindex="0">
        <h3 class="validation-header" role="none"><span role="presentation" style="padding-right: 5px" class="fa fa-info-circle"></span>${message}${spinnerDiv}</div>`);
        if (spinner) {
            $("#overlay").fadeIn(300);
        }
        $('html, body').animate({ scrollTop: (_a = $("#ValidationSummaryEntityFormControl_EntityFormView").offset()) === null || _a === void 0 ? void 0 : _a.top }, 'slow');
    }
    static openModal(appendTo, recordId, formId, websiteId, title) {
        var modal = $(`
        <section aria-label='${title}' class='modal fade modal-form modal-form-createrecord show' 
                 data-bs-backdrop='static' data-filtercriteriaid='22f322de-3b18-4999-9af9-a4d5cb148fa0' 
                 role='dialog' tabindex='-1' aria-modal='true' style='display: block;'>
            <div class='modal-lg modal-dialog'>
                <div class='modal-content'>
                    <div class='modal-header'>
                        <h1 class='modal-title' title='${title}'>${title}</h1>
                        <button aria-label='Close' class='form-close' data-bs-dismiss='modal' 
                                style='position: absolute; top: 3%;' tabindex='0' title='Close' type='button'>
                            <span aria-hidden='true'>X</span>
                            <span class='visually-hidden'>Close</span>
                        </button>
                    </div>
                    <div class='modal-body'>
                        <div class='form-loading' style='display: none;'>
                            <span class='fa fa-spinner fa-spin fa-4x' aria-hidden='true'></span>
                        </div>
                        <iframe data-page='/_portal/modal-form-template-path/${websiteId}' 
                                src='/_portal/modal-form-template-path/${websiteId}?id=${recordId}&entityformid=${formId}' 
                                title='${title}'>
                        </iframe>
                    </div>
                </div>
            </div>
        </section>
    `).appendTo(appendTo);
        var iframe = modal.find('iframe');
        iframe.on("load", function () {
            modal.find(".form-loading").hide();
            iframe.contents().find("#EntityFormControl").show();
        });
        modal.find(".form-loading").show();
        iframe.contents().find("#EntityFormControl").hide();
        modal.on("hide.bs.modal", function (e) {
            modal.remove();
        });
        modal.modal('show');
    }
    static setValidator(fieldName, add, customError = "") {
        if (typeof (Page_Validators) === 'undefined')
            return;
        if (add) {
            for (var i = 0; i < Page_Validators.length; i++) {
                var validator = Page_Validators[i];
                if (validator && validator.id === "RequiredFieldValidator" + fieldName) {
                    return;
                }
            }
            const labelName = "#" + fieldName + "_label";
            $(labelName).parent().addClass("required");
            const newValidator = document.createElement('span');
            newValidator.style.display = "none";
            newValidator.id = "RequiredFieldValidator" + fieldName;
            newValidator.controltovalidate = "casetypecode";
            newValidator.errormessage = customError == "" ? `<a href='#${fieldName}_label'>${$(labelName).text()} is a mandatory field.</a>` : customError;
            newValidator.validationGroup = "";
            newValidator.initialvalue = "";
            newValidator.evaluationfunction = function () {
                var type = $("#" + fieldName).attr('type');
                if (type == "checkbox") {
                    return $("#" + fieldName).is(':checked');
                }
                if (type == "radio") {
                    return $("input[name$='" + fieldName + "']:checked").val() === "1";
                }
                else {
                    if (fieldName.includes("confirmemail")) {
                        return $("#" + fieldName).val() === $("#" + fieldName.replace("confirm", "")).val();
                    }
                    else {
                        const value = $("#" + fieldName).val();
                        return value != null && value !== "";
                    }
                }
            };
            Page_Validators.push(newValidator);
            $(`a[href='#${fieldName}_label']`).on("click", () => {
                scrollToAndFocus(fieldName + '_label', fieldName);
            });
        }
        else {
            $.each(Page_Validators, (index, validator) => {
                if (validator && validator.id === "RequiredFieldValidator" + fieldName) {
                    Page_Validators.splice(index, 1);
                }
            });
            $("#" + fieldName + "_label").parent().removeClass("required");
        }
    }
    static toggleVisibility(attribute, condition, type = 0, required = true) {
        if (type === 0) {
            $("#" + attribute).closest("td").toggle(condition);
        }
        else {
            if (condition) {
                $("#" + attribute).closest("td").css('visibility', 'visible');
            }
            else {
                $("#" + attribute).closest("td").css('visibility', 'hidden');
            }
        }
        const validate = ["TEXTAREA", "INPUT", "SELECT"].includes($("#" + attribute).prop('nodeName'));
        if (condition) {
            required = required;
        }
        else {
            required = false;
            if (validate) {
                $("#" + attribute).val("");
            }
            else {
                $(`input[name*='${attribute}'][value='0']`).prop("checked", true);
            }
        }
        if (validate) {
            Common.setValidator(attribute, required);
        }
    }
    static toggleText() {
        const hiddenText = document.getElementById("hiddenText");
        const readMoreLink = document.getElementById("readMoreLink");
        if (readMoreLink !== null && hiddenText !== null) {
            if (hiddenText.style.display === "none" || hiddenText.style.display === "") {
                hiddenText.style.display = "block";
                readMoreLink.innerHTML = "Read Less";
            }
            else {
                hiddenText.style.display = "none";
                readMoreLink.innerHTML = "Read More";
            }
        }
    }
    static formatCurrency(event) {
        const floatVal = parseFloat($(event.currentTarget).val().replace(/,/g, ''));
        if (isNaN(floatVal)) {
            $(event.currentTarget).val(0);
        }
        else {
            $(event.currentTarget).val(floatVal.toLocaleString('en-US', { minimumFractionDigits: 2, maximumFractionDigits: 2 }));
        }
        var input = $(event.currentTarget);
        if (input.parent('div').find('.input-group-text').length === 0 && !input.parent('div').hasClass('input-group')) {
            input.wrap('<div class="input-group"></div>');
            input.before('<span class="input-group-text">&pound;</span>');
        }
    }
    static hideAllOfClass(className) {
        const selector = '.' + className;
        document.querySelectorAll(selector).forEach((list) => {
            list.style.display = 'none';
        });
    }
    static addShowSectionBtnListener(buttonId, listId, collectionClass) {
        const button = document.getElementById(buttonId);
        if (button) {
            button.addEventListener('click', () => {
                this.hideAllOfClass(collectionClass);
                const list = document.getElementById(listId);
                if (list) {
                    list.style.display = 'block';
                }
            });
        }
    }
    static validateRowLimit(max, min = 1) {
        const rows = document.querySelectorAll('.table-striped.table-fluid tbody tr');
        const rowCount = rows.length;
        if (rowCount > max) {
            Common.showMessage(`You cannot have more than ${max} contact${max > 1 ? 's' : ''}. Please remove some entries before proceeding.`, "danger");
            return false;
        }
        if (rowCount < min) {
            Common.showMessage(`You must provide at least ${min} contact${min > 1 ? 's' : ''} before proceeding.`, "danger");
            return false;
        }
        return true;
    }
    static hideColumn(columnName) {
        $(".view-grid thead th:contains(" + columnName + ")").hide();
        var createdOnIndex = $(".view-grid thead th:contains(" + columnName + ")").index() + 1;
        $(".view-grid table tr td:nth-child(" + createdOnIndex + ")").hide();
    }
    static toggleFieldsetVisibility(label, show) {
        const fieldset = $(`fieldset[aria-label="${label}"]`);
        show ? fieldset.show() : fieldset.hide();
    }
}
Common.countries = [
    "", "Afghanistan", "Albania", "Algeria", "Andorra", "Angola", "Antigua and Barbuda", "Argentina", "Armenia", "Australia", "Austria",
    "Azerbaijan", "Bahamas", "Bahrain", "Bangladesh", "Barbados", "Belarus", "Belgium", "Belize", "Benin", "Bhutan",
    "Bolivia", "Bosnia and Herzegovina", "Botswana", "Brazil", "Brunei", "Bulgaria", "Burkina Faso", "Burundi", "Cabo Verde", "Cambodia",
    "Cameroon", "Canada", "Central African Republic", "Chad", "Chile", "China", "Colombia", "Comoros", "Congo (Congo-Brazzaville)", "Congo (Democratic Republic of the)",
    "Costa Rica", "Croatia", "Cuba", "Cyprus", "Czechia (Czech Republic)", "Denmark", "Djibouti", "Dominica", "Dominican Republic",
    "Ecuador", "Egypt", "El Salvador", "Equatorial Guinea", "Eritrea", "Estonia", "Eswatini (fmr. 'Swaziland')", "Ethiopia", "Fiji", "Finland",
    "France", "Gabon", "Gambia", "Georgia", "Germany", "Ghana", "Greece", "Grenada", "Guatemala", "Guinea", "Guinea-Bissau",
    "Guyana", "Haiti", "Honduras", "Hungary", "Iceland", "India", "Indonesia", "Iran", "Iraq", "Ireland", "Israel", "Italy",
    "Jamaica", "Japan", "Jordan", "Kazakhstan", "Kenya", "Kiribati", "Kuwait", "Kyrgyzstan", "Laos", "Latvia", "Lebanon", "Lesotho",
    "Liberia", "Libya", "Liechtenstein", "Lithuania", "Luxembourg", "Madagascar", "Malawi", "Malaysia", "Maldives", "Mali", "Malta",
    "Marshall Islands", "Mauritania", "Mauritius", "Mexico", "Micronesia", "Moldova", "Monaco", "Mongolia", "Montenegro", "Morocco",
    "Mozambique", "Myanmar (Burma)", "Namibia", "Nauru", "Nepal", "Netherlands", "New Zealand", "Nicaragua", "Niger", "Nigeria", "North Korea",
    "North Macedonia", "Norway", "Oman", "Pakistan", "Palau", "Palestine", "Panama", "Papua New Guinea", "Paraguay", "Peru",
    "Philippines", "Poland", "Portugal", "Qatar", "Romania", "Russia", "Rwanda", "Saint Kitts and Nevis", "Saint Lucia",
    "Saint Vincent and the Grenadines", "Samoa", "San Marino", "Sao Tome and Principe", "Saudi Arabia", "Senegal", "Serbia", "Seychelles",
    "Sierra Leone", "Singapore", "Slovakia", "Slovenia", "Solomon Islands", "Somalia", "South Africa", "South Korea", "South Sudan",
    "Spain", "Sri Lanka", "Sudan", "Suriname", "Sweden", "Switzerland", "Syria", "Taiwan", "Tajikistan", "Tanzania", "Thailand",
    "Timor-Leste", "Togo", "Tonga", "Trinidad and Tobago", "Tunisia", "Turkey", "Turkmenistan", "Tuvalu", "Uganda", "Ukraine",
    "United Arab Emirates", "United Kingdom", "United States", "Uruguay", "Uzbekistan", "Vanuatu", "Vatican City", "Venezuela",
    "Vietnam", "Yemen", "Zambia", "Zimbabwe"
];
Common.purchaseProductId = "4ab28091-19ec-ee11-a1fd-0022481a6a6d";
Common.saleProductId = "fae68e04-e3e6-ee11-904d-000d3a86f329";
Common.purchaseAndSaleProductId = "9a843faa-19ec-ee11-a1fd-0022481a6a6d";
Common.remortgageProductId = "a6aa409e-19ec-ee11-a1fd-0022481a6a6d";


/***/ }),

/***/ "./src/contact.ts":
/*!************************!*\
  !*** ./src/contact.ts ***!
  \************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   Contact: () => (/* binding */ Contact)
/* harmony export */ });
/* harmony import */ var _common__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./common */ "./src/common.ts");

class Contact {
    static confirmPersonalDetails() {
        $("#frv_uknational").change(function () {
            const ukNational = $("#frv_uknational").val() == "100000001";
            _common__WEBPACK_IMPORTED_MODULE_0__.Common.setValidator("frv_passportnumber", !ukNational);
            _common__WEBPACK_IMPORTED_MODULE_0__.Common.setValidator("frv_nationalinsurancenumber", ukNational);
            _common__WEBPACK_IMPORTED_MODULE_0__.Common.toggleVisibility("frv_nationalinsurancenumber", ukNational);
            $("#frv_passportnumber").closest("td").toggle($("#frv_uknational").val() !== '');
        });
        $("#frv_uknational").change();
        window.webFormClientValidate = function () {
            var _a;
            var today = new Date();
            today.setHours(0, 0, 0, 0);
            if (new Date((_a = $("#birthdate").val()) === null || _a === void 0 ? void 0 : _a.toString()) < today) {
                return true;
            }
            else {
                _common__WEBPACK_IMPORTED_MODULE_0__.Common.showMessage("Invalid Date of Birth", "danger");
                return false;
            }
        };
    }
    static confirmTransactions(websiteId) {
        let observer = new MutationObserver(() => {
            var _a, _b;
            const tableBody = document.querySelector(".view-grid > table > tbody");
            if (tableBody === null || tableBody === void 0 ? void 0 : tableBody.rows) {
                observer = null;
                for (var row of tableBody.rows) {
                    const rowId = $(row).data('id');
                    var td = $(row).find('td[data-attribute="frv_transactionconfirmed"]');
                    var dataValue = td.data('value');
                    var isChecked = dataValue ? "checked" : "";
                    if (td.html().includes('checkbox'))
                        return;
                    td.html('<input type="checkbox" ' + isChecked + '>');
                    td = $(row).find('td[data-attribute="frv_transaction"]');
                    var id = JSON.parse((_b = (_a = td.attr('data-value')) === null || _a === void 0 ? void 0 : _a.toString()) !== null && _b !== void 0 ? _b : "").Id;
                    td.html(`<a href="#" onclick="Common.openModal(this.closest('.entity-grid'), '${id}', 'db72ff9e-bcfd-ee11-9f8a-000d3a86f329', '${websiteId}', 'Edit Address');">Edit Address</a>`);
                }
            }
        });
        observer.observe(document, { subtree: true, childList: true });
        // Function to handle form-level custom validation
        window.webFormClientValidate = function () {
            const tableBody = document.querySelector(".view-grid > table > tbody");
            let oneConfirmed = false;
            let allWithAddress = true;
            for (var row of tableBody.rows) {
                if ($(row).find('input[type="checkbox"]').is(':checked')) {
                    oneConfirmed = true;
                    if ($(row).find('td[data-th="Address"]').text().trim() === "") {
                        allWithAddress = false;
                    }
                }
            }
            if (!oneConfirmed) {
                _common__WEBPACK_IMPORTED_MODULE_0__.Common.showMessage("Please confirm a transaction to proceed", "danger");
            }
            if (!allWithAddress) {
                _common__WEBPACK_IMPORTED_MODULE_0__.Common.showMessage("Please enter an address for all confirmed transactions to proceed", "danger");
            }
            return oneConfirmed && allWithAddress;
        };
    }
    static confirmClientContacts(contactId, websiteId) {
        $(".entity-grid.subgrid").on("loaded", function () {
            $(this).children(".view-grid").find("tbody tr").each(function (i, e) {
                var _a, _b;
                var tr = $(this);
                var td = $(tr).find('td[data-attribute="frv_transaction"]');
                var id = JSON.parse((_b = (_a = td.attr('data-value')) === null || _a === void 0 ? void 0 : _a.toString()) !== null && _b !== void 0 ? _b : "").Id;
                _common__WEBPACK_IMPORTED_MODULE_0__.Common.safeAjax({
                    type: "GET",
                    url: `/_api/frv_transactions(${id})?$select=_frv_primarycontact_value
                    &$filter=createdon ne '${new Date().toISOString()}'`,
                    contentType: "application/json",
                    success: (result) => {
                        if (result["_frv_primarycontact_value"] === contactId) {
                            $(tr).find('td[data-attribute="frv_transaction"]')
                                .html(`<a href="#" onclick="Common.openModal(this.closest('.entity-grid'), '${id}', '6075294d-254f-ef11-a316-002248c87d52', '${websiteId}', 'Add Client');">Add Client</a>`);
                        }
                        else {
                            $(tr).find('td[data-attribute="frv_transaction"]').html(`N/A`);
                        }
                    }
                });
            });
        });
    }
}


/***/ }),

/***/ "./src/dashboard.ts":
/*!**************************!*\
  !*** ./src/dashboard.ts ***!
  \**************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   Dashboard: () => (/* binding */ Dashboard)
/* harmony export */ });
/* harmony import */ var _common__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./common */ "./src/common.ts");
var __awaiter = (undefined && undefined.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};

class Dashboard {
    static initializeDashboard(roles, useraccount, branch) {
        return __awaiter(this, void 0, void 0, function* () {
            this.setupTrendsToggle();
            this.rolesString = roles;
            this.currentUserAccount = useraccount;
            this.branchId = branch;
            this.setUserRole();
            this.viewLevel = this.userRole.toLowerCase();
            this.setupTimeFilter();
            yield Promise.all([this.loadBranches(), this.loadContacts(), this.loadEstimates()]);
            this.filterEstimates();
            this.setupBackButtons();
        });
    }
    static setUserRole() {
        // Ensure valid JSON format
        try {
            const roles = this.rolesString.trim();
            if (roles.includes("Organisation Scope"))
                this.userRole = "Organisation";
            else if (roles.includes("Branch Scope"))
                this.userRole = "Branch";
            else if (roles.includes("Contact Scope"))
                this.userRole = "Contact";
            else
                this.userRole = "None";
        }
        catch (e) {
            console.error("Failed to parse roles JSON:", this.rolesString, e);
            this.userRole = "None";
        }
    }
    static getEl(id) {
        return document.getElementById(id);
    }
    static setupTrendsToggle() {
        const btn = this.getEl("toggleTrends");
        const trendsContainer = this.getEl("trendsContainer");
        if (!btn || !trendsContainer)
            return;
        btn.addEventListener("click", () => {
            const isVisible = trendsContainer.style.display === "block";
            trendsContainer.style.display = isVisible ? "none" : "block";
            btn.innerText = isVisible ? "Show Trends" : "Hide Trends";
        });
    }
    static setupTimeFilter() {
        var _a;
        const timeFilter = this.getEl("timeFilter");
        const customDateSpan = this.getEl("customDateInputs");
        this.selectedTimePeriod = timeFilter.value;
        timeFilter.addEventListener("change", () => {
            this.selectedTimePeriod = timeFilter.value;
            customDateSpan.style.display = this.selectedTimePeriod === "custom" ? "inline-block" : "none";
            if (this.selectedTimePeriod !== "custom")
                this.filterEstimates();
        });
        (_a = this.getEl("applyCustomRange")) === null || _a === void 0 ? void 0 : _a.addEventListener("click", () => {
            this.selectedTimePeriod = "custom";
            this.filterEstimates();
        });
        const startDate = this.getEl("startDate");
        const endDate = this.getEl("endDate");
        const now = new Date();
        startDate.valueAsDate = new Date(now.getFullYear(), now.getMonth(), 1);
        endDate.valueAsDate = now;
    }
    static loadBranches() {
        return __awaiter(this, void 0, void 0, function* () {
            var _a;
            const response = yield _common__WEBPACK_IMPORTED_MODULE_0__.Common.safeAjax({ type: "GET", contentType: "application/json", url: `/_api/accounts?$select=accountid,name` });
            console.log('Branch API Response:', response);
            this.branchLookup = ((_a = response === null || response === void 0 ? void 0 : response.value) === null || _a === void 0 ? void 0 : _a.reduce((acc, branch) => {
                acc[branch.accountid] = branch.name;
                return acc;
            }, {})) || {};
        });
    }
    static loadContacts() {
        return __awaiter(this, void 0, void 0, function* () {
            var _a;
            const response = yield _common__WEBPACK_IMPORTED_MODULE_0__.Common.safeAjax({ type: "GET", contentType: "application/json", url: "/_api/contacts?$select=contactid,fullname" });
            this.contactLookup = ((_a = response === null || response === void 0 ? void 0 : response.value) === null || _a === void 0 ? void 0 : _a.reduce((acc, contact) => {
                acc[contact.contactid] = contact.fullname;
                return acc;
            }, {})) || {};
        });
    }
    static loadEstimates() {
        return __awaiter(this, void 0, void 0, function* () {
            const response = yield _common__WEBPACK_IMPORTED_MODULE_0__.Common.safeAjax({
                type: "GET",
                contentType: "application/json",
                url: `/_api/frv_transactions?$select=statuscode,_frv_referrerbranch_value,_frv_referrercontact_value,createdon,frv_referralfee&$filter=_frv_referrer_value eq '${this.currentUserAccount}'`
            });
            this.globalEstimates = (response === null || response === void 0 ? void 0 : response.value) || [];
        });
    }
    static filterEstimates() {
        const now = new Date();
        let startDate = null;
        let endDate = now;
        switch (this.selectedTimePeriod) {
            case "week": {
                // Get last week's Monday
                const today = new Date();
                const day = today.getDay(); // 0 = Sunday, 1 = Monday, etc.
                const lastMonday = new Date(today);
                lastMonday.setDate(today.getDate() - day - 6); // previous Monday
                lastMonday.setHours(0, 0, 0, 0);
                const lastSunday = new Date(lastMonday);
                lastSunday.setDate(lastMonday.getDate() + 6);
                lastSunday.setHours(23, 59, 59, 999);
                startDate = lastMonday;
                endDate = lastSunday;
                break;
            }
            case "month": {
                const now = new Date();
                const firstDayPrevMonth = new Date(now.getFullYear(), now.getMonth() - 1, 1);
                const lastDayPrevMonth = new Date(now.getFullYear(), now.getMonth(), 0); // 0 = last day of previous month
                startDate = new Date(firstDayPrevMonth.setHours(0, 0, 0, 0));
                endDate = new Date(lastDayPrevMonth.setHours(23, 59, 59, 999));
                break;
            }
            case "quarter": {
                const now = new Date();
                const currentMonth = now.getMonth();
                const currentQuarter = Math.floor(currentMonth / 3); // 0 = Q1, 1 = Q2, etc.
                // Get previous quarter’s start and end month
                const startMonth = (currentQuarter - 1 + 4) % 4 * 3; // handles rollover
                const startYear = currentQuarter === 0 ? now.getFullYear() - 1 : now.getFullYear();
                const endMonth = startMonth + 2;
                startDate = new Date(startYear, startMonth, 1);
                endDate = new Date(startYear, endMonth + 1, 0); // last day of endMonth
                endDate.setHours(23, 59, 59, 999);
                break;
            }
            case "year": {
                const now = new Date();
                const start = new Date(now.getFullYear() - 1, 0, 1); // Jan 1 last year
                const end = new Date(now.getFullYear() - 1, 11, 31); // Dec 31 last year
                end.setHours(23, 59, 59, 999);
                startDate = start;
                endDate = end;
                break;
            }
            case "month-to-date":
                startDate = new Date(now.getFullYear(), now.getMonth(), 1);
                break;
            case "custom":
                const startInput = this.getEl("startDate").value;
                const endInput = this.getEl("endDate").value;
                if (!startInput || !endInput)
                    return;
                startDate = new Date(startInput);
                endDate = new Date(endInput);
                endDate.setHours(23, 59, 59, 999);
                if (startDate > endDate)
                    return;
                break;
        }
        let estimates = [...this.globalEstimates];
        if (startDate) {
            estimates = estimates.filter(e => {
                const created = new Date(e.createdon);
                return created >= startDate && created <= endDate;
            });
        }
        if (this.selectedBranchId) {
            estimates = estimates.filter(e => e._frv_referrerbranch_value === this.selectedBranchId);
        }
        if (this.selectedUserId) {
            estimates = estimates.filter(e => e._frv_referrercontact_value === this.selectedUserId);
        }
        this.filteredEstimates = estimates;
        this.update();
    }
    static update() {
        this.setDashboardContext();
        this.updateMetrics();
        this.updateChartVisibility();
        this.updateCharts();
    }
    static setDashboardContext() {
        const ctx = this.viewLevel === "organisation" ? "All Branches" :
            this.viewLevel === "branch" ? this.branchLookup[this.selectedBranchId] || "Selected Branch" :
                this.contactLookup[this.selectedUserId] || "Selected User";
        this.getEl("dashboardContext").innerText = ctx;
    }
    static updateMetrics() {
        const totalEstimates = this.filteredEstimates.length;
        const instructedEstimates = this.filteredEstimates.filter(e => e.statuscode === 100000003).length;
        const accumulatedReferralFees = this.filteredEstimates
            .filter(e => e.statuscode === 100000003 && e.frv_referralfee)
            .reduce((sum, e) => sum + parseFloat(e.frv_referralfee || "0"), 0);
        const conversionRate = totalEstimates ? ((instructedEstimates / totalEstimates) * 100).toFixed(1) : "0.0";
        this.getEl("totalEstimates").innerText = totalEstimates.toString();
        this.getEl("instructedEstimates").innerText = instructedEstimates.toString();
        this.getEl("conversionRate").innerText = `${conversionRate}%`;
        this.getEl("referralFees").innerText = `£${accumulatedReferralFees.toFixed(2)}`;
    }
    static updateCharts() {
        this.renderUserDonutChart();
        this.renderMonthlyEstimatesChart();
        this.renderMonthlyAccumulatedReferralFeesChart();
        switch (this.viewLevel) {
            case "organisation":
                this.renderBranchChart();
                break;
            case "branch":
                this.renderUserTreemapChart();
                break;
            case "contact":
                this.renderGaugeChart();
                break;
        }
    }
    static renderGaugeChart() {
        if (this.gaugeChart)
            this.gaugeChart.destroy();
        const total = this.filteredEstimates.length;
        const instructed = this.filteredEstimates.filter(e => e.statuscode === 100000003).length;
        const conversionRate = total ? (instructed / total) * 100 : 0;
        this.gaugeChart = new ApexCharts(document.querySelector("#conversionGauge"), {
            chart: {
                type: "radialBar",
                height: 350,
                fontFamily: 'Outfit, sans-serif',
                offsetY: -20
            },
            series: [parseFloat(conversionRate.toFixed(1))],
            labels: ["Conversion Rate"],
            colors: [this.metallicPalette[3]],
            plotOptions: {
                radialBar: {
                    startAngle: -135,
                    endAngle: 135,
                    hollow: {
                        size: "70%"
                    },
                    track: {
                        background: "#f0f0f0",
                        strokeWidth: "100%"
                    },
                    dataLabels: {
                        name: {
                            fontSize: "18px",
                            offsetY: 60,
                            fontFamily: 'Outfit, sans-serif'
                        },
                        value: {
                            fontSize: "28px",
                            offsetY: -10,
                            fontWeight: 600,
                            fontFamily: 'Outfit, sans-serif',
                            formatter: (val) => `${val.toFixed(1)}%`
                        }
                    }
                }
            },
            tooltip: {
                enabled: true,
                style: {
                    fontFamily: 'Outfit, sans-serif'
                }
            }
        });
        this.gaugeChart.render();
    }
    static renderUserDonutChart() {
        if (this.donutChart)
            this.donutChart.destroy();
        const instructed = parseInt(document.getElementById("instructedEstimates").innerText);
        const total = parseInt(document.getElementById("totalEstimates").innerText);
        const notInstructed = total - instructed;
        this.donutChart = new ApexCharts(document.querySelector("#userDonutChart"), {
            chart: { type: "pie", height: 350, fontFamily: 'Outfit, sans-serif' },
            series: [instructed, notInstructed],
            labels: ['Instructed', 'Not Instructed'],
            colors: [this.metallicPalette[7], this.metallicPalette[8]],
            legend: { show: true, position: "bottom", fontFamily: 'Outfit, sans-serif' }
        });
        this.donutChart.render();
    }
    static renderMonthlyEstimatesChart() {
        if (this.monthlyEstimatesChart)
            this.monthlyEstimatesChart.destroy();
        const monthlyData = {};
        this.filteredEstimates.forEach(e => {
            const key = new Date(e.createdon).toLocaleString("default", { month: "short", year: "numeric" });
            if (!monthlyData[key])
                monthlyData[key] = { total: 0, instructed: 0 };
            monthlyData[key].total++;
            if (e.statuscode === 100000003)
                monthlyData[key].instructed++;
        });
        const sortedKeys = Object.keys(monthlyData).sort((a, b) => new Date(a).getTime() - new Date(b).getTime());
        this.monthlyEstimatesChart = new ApexCharts(document.querySelector("#monthlyEstimatesChart"), {
            chart: { type: "bar", height: 350, fontFamily: 'Outfit, sans-serif', },
            series: [
                { name: "Total Estimates", data: sortedKeys.map(k => monthlyData[k].total) },
                { name: "Instructed Estimates", data: sortedKeys.map(k => monthlyData[k].instructed) }
            ],
            xaxis: {
                categories: sortedKeys,
                axisBorder: { show: false }, // ❌ remove bottom border line
                axisTicks: { show: false } // ❌ remove small tick marks
            },
            grid: {
                xaxis: {
                    lines: { show: false } // ❌ remove vertical grid lines
                },
                yaxis: {
                    lines: { show: false } // 💥 this is the missing bit
                }
            },
            colors: [this.metallicPalette[8], this.metallicPalette[7]],
            legend: {
                show: false
            },
            plotOptions: {
                bar: {
                    borderRadius: 6,
                    columnWidth: "50%",
                    dataLabels: {
                        position: 'top'
                    }
                }
            },
            tooltip: {
                style: {
                    fontFamily: 'Outfit, sans-serif'
                }
            },
            dataLabels: {
                value: {
                    textShadow: '0px 0px 0px #000000'
                },
                enabled: true,
                offsetY: -25,
                style: {
                    fontSize: '12px',
                    colors: ["#000"],
                    fontFamily: 'Outfit, sans-serif',
                }
            }
        });
        this.monthlyEstimatesChart.render();
    }
    static renderMonthlyAccumulatedReferralFeesChart() {
        if (this.referralFeesChart)
            this.referralFeesChart.destroy();
        const feesByMonth = {};
        this.filteredEstimates
            .filter(e => e.statuscode === 100000003 && e.frv_referralfee)
            .forEach(e => {
            const key = new Date(e.createdon).toLocaleString("default", { month: "short", year: "numeric" });
            feesByMonth[key] = (feesByMonth[key] || 0) + parseFloat(e.frv_referralfee || "0");
        });
        const sortedKeys = Object.keys(feesByMonth).sort((a, b) => new Date(a).getTime() - new Date(b).getTime());
        this.referralFeesChart = new ApexCharts(document.querySelector("#monthlyAccumulatedReferralFeesChart"), {
            chart: { type: "bar", height: 350, fontFamily: 'Outfit, sans-serif' },
            series: [{ name: "Accumulated Referral Fees", data: sortedKeys.map(k => feesByMonth[k]) }],
            xaxis: {
                categories: sortedKeys,
                axisBorder: { show: false }, // ❌ remove bottom border line
                axisTicks: { show: false }, // ❌ remove small tick marks
            },
            grid: {
                xaxis: {
                    lines: { show: false } // ❌ remove vertical grid lines
                },
                yaxis: {
                    lines: { show: false } // 💥 this is the missing bit
                }
            },
            yaxis: {
                labels: {
                    style: {
                        fontFamily: 'Outfit, sans-serif'
                    },
                    formatter: (val) => val >= 1e9 ? `£${(val / 1e9).toFixed(1)}B` :
                        val >= 1e6 ? `£${(val / 1e6).toFixed(1)}M` :
                            val >= 1e3 ? `£${(val / 1e3).toFixed(1)}K` : `£${val.toFixed(0)}`
                }
            },
            colors: this.metallicPalette,
            tooltip: {
                style: {
                    fontFamily: 'Outfit, sans-serif'
                }
            },
            plotOptions: {
                bar: {
                    borderRadius: 6,
                    columnWidth: "50%",
                    dataLabels: {
                        position: 'top'
                    },
                    distributed: true
                }
            },
            legend: {
                show: false
            },
            dataLabels: {
                value: {
                    textShadow: '0px 0px 0px #000000'
                },
                enabled: true,
                offsetY: -25,
                style: {
                    fontSize: '12px',
                    colors: ["#000"],
                    fontFamily: 'Outfit, sans-serif',
                },
                formatter: function (val) {
                    return `£${val.toFixed(0)}`;
                }
            }
        });
        this.referralFeesChart.render();
    }
    static renderBranchChart() {
        if (this.branchChart)
            this.branchChart.destroy();
        if (this.userRole !== "Organisation")
            return;
        const branchStats = {};
        this.filteredEstimates.forEach(e => {
            if (e._frv_referrerbranch_value) {
                branchStats[e._frv_referrerbranch_value] = (branchStats[e._frv_referrerbranch_value] || 0) + 1;
            }
        });
        const categories = Object.keys(branchStats).map(branchId => this.branchLookup[branchId] || `Unknown Branch`);
        const totalEstimates = Object.values(branchStats);
        this.branchChart = new ApexCharts(document.querySelector("#branchChart"), {
            chart: {
                type: "bar",
                height: 340,
                fontFamily: 'Outfit, sans-serif',
                toolbar: { show: false },
                offsetX: -20, // 🧽 pull chart closer to the left if needed
                events: {
                    dataPointSelection: (event, chartContext, config) => {
                        const selectedBranchId = Object.keys(branchStats)[config.dataPointIndex];
                        this.handleBranchSelection(selectedBranchId);
                    }
                }
            },
            plotOptions: {
                bar: {
                    horizontal: true,
                    borderRadius: 6,
                    barHeight: "60%",
                    distributed: true // 👈 revert to single color, legend works again
                }
            },
            series: [{
                    name: "Total Estimates",
                    data: totalEstimates
                }],
            grid: {
                show: false
            },
            yaxis: {
                show: false // ❌ completely hides the Y-axis labels (branch names)
            },
            xaxis: {
                categories: categories,
                labels: {
                    style: {
                        fontSize: '14px',
                        fontFamily: 'Outfit, sans-serif'
                    }
                }
            },
            tooltip: {
                style: { fontFamily: 'Outfit, sans-serif' },
                y: {
                    formatter: function (val) {
                        return `${val} estimate${val !== 1 ? "s" : ""}`;
                    }
                }
            },
            legend: {
                show: true,
                position: "bottom",
                fontFamily: 'Outfit, sans-serif'
            },
            dataLabels: {
                enabled: true,
                formatter: function (val) {
                    return `${val}`; // ✅ only show the number
                },
                style: {
                    fontSize: '12px',
                    colors: ["#000"],
                    fontFamily: 'Outfit, sans-serif'
                },
                offsetX: 10,
                align: 'left'
            },
            colors: this.metallicPalette // or any consistent color
        });
        this.branchChart.render();
    }
    static renderUserTreemapChart() {
        if (this.userTreemapChart)
            this.userTreemapChart.destroy();
        if (this.userRole === "Contact")
            return; // Contact-level users don't have a Treemap
        const userStats = {};
        this.filteredEstimates.forEach(e => {
            if (e._frv_referrercontact_value) {
                userStats[e._frv_referrercontact_value] = (userStats[e._frv_referrercontact_value] || 0) + 1;
            }
        });
        const userData = Object.keys(userStats).map(userId => ({
            x: this.contactLookup[userId] || "Unknown User",
            y: userStats[userId],
            userId
        }));
        this.userTreemapChart = new ApexCharts(document.querySelector("#userTreemap"), {
            chart: {
                type: "treemap",
                height: 300,
                fontFamily: 'Outfit, sans-serif',
                events: {
                    dataPointSelection: (event, chartContext, config) => {
                        const selectedUserId = userData[config.dataPointIndex].userId;
                        this.handleUserSelection(selectedUserId);
                    }
                }
            },
            series: [{ data: userData }],
            fill: {
                colors: this.metallicPalette
            },
            stroke: {
                show: true,
                width: 2,
                colors: ['#000000'] // 💥 black outline
            },
            plotOptions: {
                treemap: {
                    dataLabels: {
                        enabled: true,
                        style: {
                            fontSize: '14px',
                            fontWeight: 600,
                            fontFamily: 'Outfit, sans-serif',
                            colors: ['#ffffff'], // Light text for contrast
                            textShadow: '1px 1px 3px #000000' // 💥 Add this for shadow
                        }
                    },
                    distributed: true
                }
            },
            tooltip: {
                style: { fontFamily: 'Outfit, sans-serif' },
                custom: (opts) => {
                    const data = opts.w.config.series[opts.seriesIndex].data[opts.dataPointIndex];
                    const instructed = Dashboard.filteredEstimates.filter(e => e._frv_referrercontact_value === data.userId &&
                        e.statuscode === 100000003).length;
                    return `<div style="padding:5px"><strong>${data.x}</strong><br/>Total Estimates: ${data.y}<br/>Instructions: ${instructed}</div>`;
                }
            }
        });
        this.userTreemapChart.render();
    }
    static toggleVisibility(id, show) {
        const el = this.getEl(id);
        if (el)
            el.style.display = show ? "block" : "none";
    }
    static updateChartVisibility() {
        const allElements = [
            "branchChart",
            "userTreemap",
            "conversionGauge",
            "backToBranch",
            "backToUserTreemap"
        ];
        // Hide everything first
        allElements.forEach(id => this.toggleVisibility(id, false));
        switch (this.userRole) {
            case "Organisation":
                if (this.viewLevel === "organisation") {
                    this.toggleVisibility("branchChart", true);
                }
                else if (this.viewLevel === "branch") {
                    this.toggleVisibility("userTreemap", true);
                    this.toggleVisibility("backToBranch", true);
                }
                else if (this.viewLevel === "contact") {
                    this.toggleVisibility("conversionGauge", true);
                    this.toggleVisibility("backToUserTreemap", true);
                }
                break;
            case "Branch":
                if (this.viewLevel === "branch") {
                    this.toggleVisibility("userTreemap", true);
                }
                else if (this.viewLevel === "contact") {
                    this.toggleVisibility("conversionGauge", true);
                    this.toggleVisibility("backToUserTreemap", true);
                }
                break;
            case "Contact":
                this.toggleVisibility("conversionGauge", true);
                break;
        }
    }
    static handleBranchSelection(branchId) {
        this.viewLevel = "branch";
        this.selectedBranchId = branchId;
        this.selectedUserId = null;
        this.filterEstimates(); // Will use the selected branch and current time filter
    }
    static handleUserSelection(userId) {
        this.viewLevel = "contact";
        this.selectedUserId = userId;
        this.filterEstimates(); // Will use the selected user and time filter
    }
    static setupBackButtons() {
        var _a, _b;
        (_a = this.getEl("backToBranch")) === null || _a === void 0 ? void 0 : _a.addEventListener("click", () => {
            this.viewLevel = "organisation";
            this.selectedBranchId = null;
            this.selectedUserId = null;
            this.filterEstimates();
        });
        (_b = this.getEl("backToUserTreemap")) === null || _b === void 0 ? void 0 : _b.addEventListener("click", () => {
            this.viewLevel = "branch";
            this.selectedUserId = null;
            this.filterEstimates();
        });
    }
}
Dashboard.globalEstimates = [];
Dashboard.filteredEstimates = [];
Dashboard.branchLookup = {};
Dashboard.contactLookup = {};
Dashboard.userRole = "None";
Dashboard.selectedTimePeriod = "month-to-date";
Dashboard.selectedBranchId = null;
Dashboard.selectedUserId = null;
Dashboard.metallicPalette = [
    '#f4008a', // Magenta/Pink
    '#ef7467', // Coral/Salmon
    '#8624e0', // Purple
    '#f8ab00', // Orange
    '#6eccf0', // Light Sky Blue
    '#00f7ff', // Electric Cyan
    '#ff595e', // Tomato Red
    '#2dd4bf', // Mint Green
    '#388feb', // Blue
    //'#D2042D', //Cherry
    //'#00BFFF', //Blue
    //'#36a956', //Lime
    //'#FF00FF', //Magenta
    //'#EC5800', //Persimmon
    //'#FFD700', //Gold
    //'#FF1493'  //DeepPink
    //old values
    //'#d4af37', // Gold
    //'#cd7f32', // Bronze
    //'#c0c0c0', // Silver
    //'#4682b4', // Steel Blue
    //'#a52a2a', // Oxidized Copper (reddish bronze)
    //'#708090', // Slate Gray
    //'#b87333'  // Copper
];


/***/ }),

/***/ "./src/estimate.ts":
/*!*************************!*\
  !*** ./src/estimate.ts ***!
  \*************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   Estimate: () => (/* binding */ Estimate)
/* harmony export */ });
/* harmony import */ var _address__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./address */ "./src/address.ts");
/* harmony import */ var _common__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./common */ "./src/common.ts");


class Estimate {
    static referrerLogic(leadId, stepId) {
        $("#frv_sourceofbusiness_name").attr("value", "External Referrer");
        $("#frv_sourceofbusiness").attr("value", "39267ba5-9a08-f011-bae3-002248008b2b");
        $("#frv_sourceofbusiness_entityname").attr("value", "frv_sourceofbusiness");
        $('#frv_sourceofbusiness').parent().closest('td').hide();
        $('#frv_referrer').parent().closest('td').hide();
        $('#frv_referrerbranch').parent().closest('td').hide();
        $('#frv_referrercontact').parent().closest('td').hide();
        $('#frv_mattertype').parent().closest('td').hide();
        _common__WEBPACK_IMPORTED_MODULE_1__.Common.safeAjax({
            type: "GET",
            url: `/_api/frv_leads(${leadId})?$select=_frv_product_value&$expand=frv_Product($select=frv_name)`,
            contentType: "application/json",
            success: (result) => {
                if (result._frv_product_value) {
                    $("#frv_product").attr("value", result._frv_product_value);
                    $("#frv_product_entityname").attr("value", "frv_product");
                    $("#frv_product_name").attr("value", result.frv_Product.frv_name);
                    if (result._frv_product_value === "9a843faa-19ec-ee11-a1fd-0022481a6a6d") {
                        $("#frv_leadproduct").attr("value", result._frv_product_value);
                        $("#frv_leadproduct_entityname").attr("value", "frv_product");
                        $("#frv_leadproduct_name").attr("value", "Purchase and Sale");
                        let productId = "";
                        let productName = result.frv_Product.frv_name;
                        if (stepId === 1 /* Create Transaction */) {
                            productId = "4ab28091-19ec-ee11-a1fd-0022481a6a6d";
                            productName = "Purchase";
                        }
                        else {
                            productId = "fae68e04-e3e6-ee11-904d-000d3a86f329";
                            productName = "Sale";
                        }
                        $("#frv_product").attr("value", productId);
                        $("#frv_product_entityname").attr("value", "frv_product");
                        $("#frv_product_name").attr("value", productName);
                    }
                    var referrerBranchId = $('#frv_referrerbranch').val();
                    var productValue = $("#frv_product").val();
                    _common__WEBPACK_IMPORTED_MODULE_1__.Common.toggleVisibility("frv_newbuild", productValue === _common__WEBPACK_IMPORTED_MODULE_1__.Common.purchaseProductId || productValue === _common__WEBPACK_IMPORTED_MODULE_1__.Common.purchaseAndSaleProductId);
                    _common__WEBPACK_IMPORTED_MODULE_1__.Common.toggleVisibility("frv_isthereamortgage", productValue === _common__WEBPACK_IMPORTED_MODULE_1__.Common.saleProductId || productValue === _common__WEBPACK_IMPORTED_MODULE_1__.Common.purchaseAndSaleProductId, undefined, false);
                    _common__WEBPACK_IMPORTED_MODULE_1__.Common.toggleVisibility("frv_anygifteddeposits", productValue === _common__WEBPACK_IMPORTED_MODULE_1__.Common.purchaseProductId || productValue === _common__WEBPACK_IMPORTED_MODULE_1__.Common.purchaseAndSaleProductId, undefined, false);
                    _common__WEBPACK_IMPORTED_MODULE_1__.Common.toggleVisibility("frv_mortgagerequired", productValue === _common__WEBPACK_IMPORTED_MODULE_1__.Common.purchaseProductId, undefined, false);
                    _common__WEBPACK_IMPORTED_MODULE_1__.Common.toggleVisibility("frv_newmortgageamount", productValue === _common__WEBPACK_IMPORTED_MODULE_1__.Common.remortgageProductId);
                    const priceLabel = document.getElementById('frv_price_label');
                    if (productValue === _common__WEBPACK_IMPORTED_MODULE_1__.Common.remortgageProductId && priceLabel)
                        priceLabel.textContent = 'Property Value';
                    var fetchXml = `<fetch top="1">
                          <entity name="frv_pricelist">
                            <attribute name="frv_pricelistid"/>
                            <attribute name="frv_name"/>
                            <filter type="and">
                              <condition attribute="frv_referrer" operator="eq" value='${referrerBranchId}'/>
                              <condition attribute="frv_product" operator="eq" value='${productValue}'/>
                              <condition attribute="frv_defaultforreferrer" operator="eq" value='1'/>
                            </filter>
                          </entity>
                        </fetch>`;
                    var encodedFetchXml = encodeURIComponent(fetchXml);
                    var url = `/_api/frv_pricelists?fetchXml=${encodedFetchXml}`;
                    _common__WEBPACK_IMPORTED_MODULE_1__.Common.safeAjax({
                        type: "GET",
                        url: url,
                        contentType: "application/json",
                        success: function (results) {
                            if (results.value && results.value.length > 0) {
                                var priceList = results.value[0];
                                $("#frv_pricelist_name").attr("value", priceList.frv_name);
                                $("#frv_pricelist").attr("value", priceList.frv_pricelistid);
                                $("#frv_pricelist_entityname").attr("value", "frv_pricelist");
                            }
                        }
                    });
                    if (productValue !== "") {
                        const matterType = [{
                                id: "",
                                name: "",
                                entityType: "frv_mattertype"
                            }];
                        switch (productValue) {
                            case _common__WEBPACK_IMPORTED_MODULE_1__.Common.purchaseProductId:
                                matterType[0].id = "cf9c7cc8-c484-ef11-ac21-0022481b5955";
                                matterType[0].name = "Purchase of Home";
                                break;
                            case _common__WEBPACK_IMPORTED_MODULE_1__.Common.saleProductId:
                                matterType[0].id = "1717492e-7485-ef11-ac20-6045bd0c4d0b";
                                matterType[0].name = "Sale of Home";
                                break;
                            case _common__WEBPACK_IMPORTED_MODULE_1__.Common.remortgageProductId:
                                matterType[0].id = "c660127d-edc9-ef11-a72f-6045bd0c8dd5";
                                matterType[0].name = "Remortgage of Home";
                                break;
                            default:
                        }
                        $("#frv_mattertype").attr("value", matterType[0].id);
                        $("#frv_mattertype_entityname").attr("value", matterType[0].entityType);
                        $("#frv_mattertype_name").attr("value", matterType[0].name);
                    }
                    else {
                        $("#frv_mattertype").attr("value", null);
                    }
                }
            }
        });
        $("#frv_lead").attr("value", leadId);
        $("#frv_lead_entityname").attr("value", "frv_lead");
        $('#frv_lead').parent().closest('td').hide();
        $('#frv_leadproduct').parent().closest('td').hide();
        setTimeout(() => { $('#frv_product').siblings("button").prop("disabled", true).hide(); }, 10);
        window.webFormClientValidate = function () {
            const result = _address__WEBPACK_IMPORTED_MODULE_0__.Address.validatePostcode('frv_address1');
            return result;
        };
        new _address__WEBPACK_IMPORTED_MODULE_0__.Address('frv_address1', 'frv_addresssearch');
        _address__WEBPACK_IMPORTED_MODULE_0__.Address.countryAsDropdown('frv_address1_country');
        _common__WEBPACK_IMPORTED_MODULE_1__.Common.setValidator('frv_address1_country', true);
        _common__WEBPACK_IMPORTED_MODULE_1__.Common.setValidator("frv_buytoletlimitedcompany", false);
        _common__WEBPACK_IMPORTED_MODULE_1__.Common.setValidator("frv_tenure", true);
        _common__WEBPACK_IMPORTED_MODULE_1__.Common.setValidator("frv_price", true);
        _common__WEBPACK_IMPORTED_MODULE_1__.Common.setValidator("frv_address1_line1", true);
        _common__WEBPACK_IMPORTED_MODULE_1__.Common.setValidator("frv_address1_city", true);
        _common__WEBPACK_IMPORTED_MODULE_1__.Common.setValidator("frv_address1_postalcode", true);
        _common__WEBPACK_IMPORTED_MODULE_1__.Common.setValidator("frv_address1_country", true);
        _common__WEBPACK_IMPORTED_MODULE_1__.Common.setValidator("frv_pricelist", true);
        $("#frv_price").on('change', _common__WEBPACK_IMPORTED_MODULE_1__.Common.formatCurrency);
        $("#frv_price").trigger('change');
        $("#frv_newmortgageamount").on('change', _common__WEBPACK_IMPORTED_MODULE_1__.Common.formatCurrency);
        $("#frv_newmortgageamount").trigger('change');
    }
    static confirmClientContacts(type = 0) {
        let observer = new MutationObserver(() => {
            const tableBody = document.querySelector(".view-grid > table > tbody");
            if (tableBody === null || tableBody === void 0 ? void 0 : tableBody.rows) {
                observer = null;
                for (var row of tableBody.rows) {
                    const rowId = $(row).data('id');
                    var td = $(row).find('td[data-attribute="frv_primarycontact"]');
                    var dataValue = td.data('value');
                    var isChecked = dataValue ? "checked" : "";
                    if (td.html().includes('checkbox'))
                        return;
                    td.html('<input type="checkbox" ' + isChecked + '>');
                    td.find('input[type="checkbox"]').on('click', function () {
                        _common__WEBPACK_IMPORTED_MODULE_1__.Common.safeAjax({
                            type: "PUT",
                            url: `/_api/frv_contacttransactions(${$(row).data('id')})/frv_primarycontact`,
                            contentType: "application/json",
                            data: JSON.stringify({ "value": $(this).is(':checked') })
                        });
                    });
                }
            }
        });
        observer.observe(document, { subtree: true, childList: true });
        if (type === 0) {
            window.webFormClientValidate = function () {
                var _a;
                if (!_common__WEBPACK_IMPORTED_MODULE_1__.Common.validateRowLimit(4))
                    return false;
                var tableBody = document.querySelector(".view-grid > table > tbody");
                var count = 0;
                for (var row of tableBody.rows) {
                    if ($(row).find('input[type="checkbox"]').is(':checked')) {
                        count++;
                    }
                }
                if (count !== 1) {
                    _common__WEBPACK_IMPORTED_MODULE_1__.Common.showMessage("There must be one primary contact set in order to proceed", "danger");
                }
                else {
                    const leadId = (_a = $('#EntityFormView_EntityID').val()) === null || _a === void 0 ? void 0 : _a.toString();
                    if (leadId) {
                        const currentAction = $("#liquid_form").attr('action');
                        const separator = (currentAction === null || currentAction === void 0 ? void 0 : currentAction.includes('?')) ? '&' : '?';
                        const newAction = currentAction + separator + 'leadId=' + encodeURIComponent(leadId);
                        $("#liquid_form").attr('action', newAction);
                    }
                }
                return count === 1;
            };
        }
        else {
            window.webFormClientValidate = function () {
                var _a;
                if (!_common__WEBPACK_IMPORTED_MODULE_1__.Common.validateRowLimit(4))
                    return false;
                var tableBody = document.querySelector(".view-grid > table > tbody");
                var count = 0;
                let primaryContacts = [];
                let valid = true;
                for (var row of tableBody.rows) {
                    if ($(row).find('input[type="checkbox"]').is(':checked')) {
                        let addToValue = $(row).find('[data-attribute="frv_addto"]').data('value');
                        primaryContacts.push(addToValue.Value);
                    }
                }
                let counts = {
                    all: primaryContacts.filter(val => val === 100000000).length, // 'All'
                    sale: primaryContacts.filter(val => val === 100000001).length, // 'Sale'
                    purchase: primaryContacts.filter(val => val === 100000002).length // 'Purchase'
                };
                // Validate conditions
                if (counts.all > 1 || counts.sale > 1 || counts.purchase > 1) {
                    // More than one primary contact for any category is invalid
                    valid = false;
                }
                else if (counts.all > 0) {
                    // If 'All' is present, there must not be any for 'Sale' or 'Purchase'
                    if (counts.sale > 0 || counts.purchase > 0) {
                        valid = false;
                    }
                }
                else {
                    // If 'All' is not present, there must be exactly one for both 'Sale' and 'Purchase'.
                    if (counts.sale !== 1 || counts.purchase !== 1) {
                        valid = false;
                    }
                }
                if (!valid) {
                    _common__WEBPACK_IMPORTED_MODULE_1__.Common.showMessage("There must be one primary contact for both purchase and sale set in order to proceed", "danger");
                }
                else {
                    const leadId = (_a = $('#EntityFormView_EntityID').val()) === null || _a === void 0 ? void 0 : _a.toString();
                    if (leadId) {
                        const currentAction = $("#liquid_form").attr('action');
                        const separator = (currentAction === null || currentAction === void 0 ? void 0 : currentAction.includes('?')) ? '&' : '?';
                        const newAction = currentAction + separator + 'leadId=' + encodeURIComponent(leadId);
                        $("#liquid_form").attr('action', newAction);
                    }
                }
                return valid;
            };
        }
    }
}


/***/ }),

/***/ "./src/lead.ts":
/*!*********************!*\
  !*** ./src/lead.ts ***!
  \*********************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   Lead: () => (/* binding */ Lead)
/* harmony export */ });
/* harmony import */ var _common__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./common */ "./src/common.ts");
var __awaiter = (undefined && undefined.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};

class Lead {
    static purchaseAndSaleSelector(leadId) {
        _common__WEBPACK_IMPORTED_MODULE_0__.Common.safeAjax({
            type: "GET",
            url: `/_api/frv_leads(${leadId})?$select=_frv_product_value`,
            contentType: "application/json",
            success: (result) => {
                const purchaseAndSale = result._frv_product_value === "9a843faa-19ec-ee11-a1fd-0022481a6a6d";
                $("#frv_addto").closest("td").toggle(purchaseAndSale);
                _common__WEBPACK_IMPORTED_MODULE_0__.Common.setValidator("frv_addto", purchaseAndSale);
            }
        });
    }
    static createLeadValidation(leadId = "") {
        $("#frv_sourceofbusiness_name").attr("value", "External Referrer");
        $("#frv_sourceofbusiness").attr("value", "39267ba5-9a08-f011-bae3-002248008b2b");
        $("#frv_sourceofbusiness_entityname").attr("value", "frv_sourceofbusiness");
        setTimeout(() => {
            $('#frv_sourceofbusiness').siblings("button").prop("disabled", true).hide();
            $('#frv_sourceofbusiness').parent().closest('td').hide();
            $('#frv_referrer').siblings("button").prop("disabled", true).hide();
            $('#frv_referrer').parent().closest('td').hide();
            $('#frv_referrerbranch').siblings("button").prop("disabled", true).hide();
            $('#frv_referrerbranch').parent().closest('td').hide();
            $('#frv_referrercontact').siblings("button").prop("disabled", true).hide();
            $('#frv_referrercontact').parent().closest('td').hide();
        }, 10);
        if (leadId !== "") {
            _common__WEBPACK_IMPORTED_MODULE_0__.Common.safeAjax({
                type: "GET",
                url: `/_api/frv_transactions?$select=frv_transactionid&$filter=_frv_lead_value eq '${leadId}'`,
                contentType: "application/json",
                success: (results) => {
                    if (results.entities.length > 1) {
                        const currentAction = $("#liquid_form").attr('action');
                        const separator = (currentAction === null || currentAction === void 0 ? void 0 : currentAction.includes('?')) ? '&' : '?';
                        const newAction = currentAction + separator + 'transactionId2=' + encodeURIComponent(results.entities[1].frv_transactionid);
                        $("#liquid_form").attr('action', newAction);
                    }
                    if (results.entities.length > 0) {
                        const currentAction = $("#liquid_form").attr('action');
                        const separator = (currentAction === null || currentAction === void 0 ? void 0 : currentAction.includes('?')) ? '&' : '?';
                        const newAction = currentAction + separator + 'transactionId1=' + encodeURIComponent(results.entities[0].frv_transactionid);
                        $("#liquid_form").attr('action', newAction);
                    }
                    else {
                    }
                }
            });
        }
    }
    static leadInititaliseContacts() {
        return __awaiter(this, void 0, void 0, function* () {
            const entityId = $("#EntityFormView_EntityID").val() || "";
            let existingClientContacts = yield Lead.getExistingContactsForLead(entityId);
            Lead.onSaveCreateClientContacts(existingClientContacts);
        });
    }
    static getExistingContactsForLead(leadId) {
        return __awaiter(this, void 0, void 0, function* () {
            if (!leadId)
                return new Set();
            const query = `/_api/frv_contacttransactions?$select=_frv_contact_value&$filter=_frv_lead_value eq '${leadId}'`;
            return new Promise((resolve) => {
                _common__WEBPACK_IMPORTED_MODULE_0__.Common.safeAjax({
                    type: "GET",
                    contentType: "application/json",
                    url: query,
                    success: (data) => {
                        var _a;
                        const contacts = new Set(((_a = data === null || data === void 0 ? void 0 : data.value) === null || _a === void 0 ? void 0 : _a.map((record) => record._frv_contact_value.toLowerCase().trim())) || []);
                        resolve(contacts);
                    },
                    error: () => {
                        resolve(new Set());
                    }
                });
            });
        });
    }
    static onSaveCreateClientContacts(existingClientContacts) {
        var _a;
        const entityId = ((_a = $("#EntityFormView_EntityID").val()) === null || _a === void 0 ? void 0 : _a.toString().trim()) || "";
        window.webFormClientValidate = function () {
            if (!_common__WEBPACK_IMPORTED_MODULE_0__.Common.validateRowLimit(4))
                return false;
            const rows = document.querySelectorAll('.table-striped.table-fluid tbody tr');
            const newContacts = Array.from(rows)
                .map(row => { var _a, _b; return (_b = (_a = row.getAttribute("data-id")) === null || _a === void 0 ? void 0 : _a.toLowerCase().trim()) !== null && _b !== void 0 ? _b : ""; })
                .filter(contactId => contactId !== "" && !existingClientContacts.has(contactId));
            if (!newContacts.length)
                return true;
            newContacts.forEach(contactId => {
                Lead.createClientContactNonBlocking(contactId, entityId);
            });
            for (const end = Date.now() + 3000; Date.now() < end;)
                ;
            return true;
        };
        return false;
    }
    static createClientContactNonBlocking(contactId, leadId) {
        if (!contactId || !leadId)
            return;
        _common__WEBPACK_IMPORTED_MODULE_0__.Common.safeAjax({
            type: "POST",
            contentType: "application/json",
            url: "/_api/frv_contacttransactions",
            data: JSON.stringify({
                "frv_Contact@odata.bind": `/contacts(${contactId})`,
                "frv_Lead@odata.bind": `/frv_leads(${leadId})`
            })
        });
    }
}


/***/ }),

/***/ "./src/message.ts":
/*!************************!*\
  !*** ./src/message.ts ***!
  \************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   Message: () => (/* binding */ Message)
/* harmony export */ });
/* harmony import */ var _common__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./common */ "./src/common.ts");

class Message {
    static initializeMessages() {
        var _a;
        const unreadMessages = document.querySelectorAll(".chat-message.unread[data-id]");
        unreadMessages.forEach((msgEl) => {
            const id = msgEl.getAttribute("data-id");
            if (!id)
                return;
            const record = {
                statuscode: 2,
                statecode: 1
            };
            _common__WEBPACK_IMPORTED_MODULE_0__.Common.safeAjax({
                type: "PATCH",
                url: `/_api/frv_portalmessages(${id})`,
                contentType: "application/json",
                data: JSON.stringify(record),
                success: function (data, textStatus, xhr) {
                    console.log("Record updated");
                },
                error: function (xhr, textStatus, errorThrown) {
                    console.log(xhr);
                }
            });
        });
        const firstUnread = document.querySelector(".chat-message.unread");
        if (firstUnread) {
            firstUnread.scrollIntoView({
                behavior: "smooth",
                block: "center"
            });
            setTimeout(() => {
                firstUnread.classList.add("glow");
            }, 400);
        }
        (_a = document.getElementById("sendMessageBtn")) === null || _a === void 0 ? void 0 : _a.addEventListener("click", () => {
            const messageText = document.getElementById("newMessageText").value.trim();
            const statusDiv = document.getElementById("sendMessageStatus");
            const sendBtn = document.getElementById("sendMessageBtn");
            if (!messageText) {
                statusDiv.innerText = "Please type a message.";
                statusDiv.style.color = "red";
                statusDiv.style.display = "block";
                return;
            }
            sendBtn.disabled = true;
            statusDiv.innerText = "Sending...";
            statusDiv.style.color = "black";
            statusDiv.style.display = "block";
            const payload = {
                description: messageText,
                subject: `${referrerName} > ${ownerName}`,
                frv_direction: 1,
                statuscode: 1,
                statecode: 0,
                "regardingobjectid_frv_transaction@odata.bind": `/frv_transactions(${estimateId})`,
                "frv_Contact_frv_portalmessage@odata.bind": `/contacts(${contactId})`
            };
            _common__WEBPACK_IMPORTED_MODULE_0__.Common.safeAjax({
                type: "POST",
                url: "/_api/frv_portalmessages",
                contentType: "application/json",
                data: JSON.stringify(payload)
            }).then(() => {
                const newMessage = document.createElement("div");
                newMessage.className = "chat-message inbound unread glow";
                newMessage.innerHTML = `
      <div class="message-content">
        <h3>${payload.subject} - <small>${new Date().toLocaleString("en-GB", {
                    day: "2-digit",
                    month: "short",
                    year: "numeric",
                    hour: "2-digit",
                    minute: "2-digit"
                })}</small>
          <span class="new-indicator">NEW</span>
        </h3>
        <hr />
        <div class="message-body">${messageText.replace(/\n/g, "<br>")}</div>
      </div>
    `;
                const thread = document.querySelector(".chat-thread");
                if (thread) {
                    thread.prepend(newMessage);
                    newMessage.scrollIntoView({ behavior: "smooth", block: "center" });
                }
                document.getElementById("newMessageText").value = "";
                statusDiv.innerText = "Message sent!";
                statusDiv.style.color = "green";
                setTimeout(() => {
                    statusDiv.style.display = "none";
                    sendBtn.disabled = false;
                    newMessage.classList.remove("glow");
                }, 2000);
            }).catch((err) => {
                console.error("Failed to send message:", err);
                statusDiv.innerText = "Failed to send message.";
                statusDiv.style.color = "red";
                sendBtn.disabled = false;
            });
        });
    }
}


/***/ }),

/***/ "./src/questionnaire.ts":
/*!******************************!*\
  !*** ./src/questionnaire.ts ***!
  \******************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   Questionnaire: () => (/* binding */ Questionnaire)
/* harmony export */ });
/* harmony import */ var _address__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./address */ "./src/address.ts");
/* harmony import */ var _common__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./common */ "./src/common.ts");


class Questionnaire {
    static InitializeQuestionnaire(transactionId) {
        $("#liquid_form").prepend(`<div id="overlay-full">
          <div class="cv-spinner">
            <span class="spinner-big"></span>
          </div>
        </div>`);
        $("#overlay-full").fadeIn(300);
        $("#frv_transaction_name").attr("value", "Transaction");
        $("#frv_transaction").attr("value", transactionId);
        $("#frv_transaction_entityname").attr("value", "frv_transaction");
        $("#frv_name").closest("td").hide();
        $("#frv_transaction").closest("td").hide();
        $("#frv_type").closest("td").hide();
        _common__WEBPACK_IMPORTED_MODULE_1__.Common.safeAjax({
            type: "GET",
            url: `/_api/frv_transactions(${transactionId})?$select=frv_sharedownership,frv_staircasing,_frv_product_value,frv_newmortgageamount,frv_auctionsale`,
            headers: {
                "Accept": "application/json",
                "OData-MaxVersion": "4.0",
                "OData-Version": "4.0"
            },
            success: function (result) {
                var _a, _b;
                const isSharedOwnership = result.frv_sharedownership;
                const isStaircasing = result.frv_staircasing;
                const productName = (_b = (_a = result["_frv_product_value@OData.Community.Display.V1.FormattedValue"]) === null || _a === void 0 ? void 0 : _a.toLowerCase()) !== null && _b !== void 0 ? _b : "unknown";
                const newMortgageAmount = result.frv_newmortgageamount;
                $("#frv_newmortgageamount").val(newMortgageAmount);
                switch (productName) {
                    case "sale":
                        Questionnaire.setupSaleQuestionnaire(isSharedOwnership, result.frv_auctionsale);
                        break;
                    case "purchase":
                        Questionnaire.setupPurchaseQuestionnaire(isSharedOwnership);
                        break;
                    case "remortgage":
                        Questionnaire.setupRemortgageQuestionnaire(isStaircasing);
                        $("#frv_newmortgageamount").val(newMortgageAmount);
                        break;
                    default:
                        console.warn("No questionnaire setup for product:", productName);
                        break;
                }
                if ($("#frv_confirmrelatedtransaction").length > 0) {
                    _common__WEBPACK_IMPORTED_MODULE_1__.Common.setValidator("frv_confirmrelatedtransaction", true);
                }
                $("#overlay-full").fadeOut(300);
            }
        });
    }
    static setupSaleQuestionnaire(isSharedOwnership, auction = false) {
        _common__WEBPACK_IMPORTED_MODULE_1__.Common.toggleFieldsetVisibility("Shared Ownership", isSharedOwnership);
        _common__WEBPACK_IMPORTED_MODULE_1__.Common.toggleVisibility("frv_ownedpercentage", isSharedOwnership);
        _common__WEBPACK_IMPORTED_MODULE_1__.Common.setValidator("frv_ownedpercentage", isSharedOwnership);
        _common__WEBPACK_IMPORTED_MODULE_1__.Common.toggleVisibility("frv_whoisthehousingassociation", isSharedOwnership);
        _common__WEBPACK_IMPORTED_MODULE_1__.Common.setValidator("frv_whoisthehousingassociation", isSharedOwnership);
        _common__WEBPACK_IMPORTED_MODULE_1__.Common.toggleVisibility("frv_estateagentinvolved", !auction);
        if (auction) {
            $($("#QuickviewControl1723546080934")[0].contentWindow.document).find("#frv_price").closest('td').hide();
            $("#QuickviewControl1723546080934").css('height', '50%');
        }
        this.setVisibilitiesSale();
        $("select").change(this.setVisibilitiesSale);
        const initialRequired = [
            "frv_estateagentinvolved",
            "frv_mortgagechargeregistered",
            "frv_otherslivingatproperty",
            "frv_confirmrelatedtransaction",
        ];
        initialRequired.forEach(selector => _common__WEBPACK_IMPORTED_MODULE_1__.Common.toggleVisibility(selector, true));
        new _address__WEBPACK_IMPORTED_MODULE_0__.Address('address1', 'frv_transactionaddressandprice');
    }
    static setVisibilitiesSale() {
        _common__WEBPACK_IMPORTED_MODULE_1__.Common.toggleVisibility("frv_estateagentdetails", $("#frv_estateagentinvolved").val() === "100000001");
        _common__WEBPACK_IMPORTED_MODULE_1__.Common.toggleVisibility("frv_detailsofotherslivingatproperty", $("#frv_otherslivingatproperty").val() === "100000001");
        _common__WEBPACK_IMPORTED_MODULE_1__.Common.toggleVisibility("frv_transactionaddressandprice", $("#frv_confirmrelatedtransaction").val() === "100000001");
        _common__WEBPACK_IMPORTED_MODULE_1__.Common.toggleVisibility("frv_reasonforsale", $("#frv_confirmrelatedtransaction").val() === "100000000");
        $("#Subgrid_Mortgages").closest("td").toggle($("#frv_mortgagechargeregistered").val() === "100000001");
    }
    static setupPurchaseQuestionnaire(isSharedOwnership) {
        _common__WEBPACK_IMPORTED_MODULE_1__.Common.toggleFieldsetVisibility("Shared Ownership", isSharedOwnership);
        _common__WEBPACK_IMPORTED_MODULE_1__.Common.toggleVisibility("frv_ownedpercentage", isSharedOwnership);
        _common__WEBPACK_IMPORTED_MODULE_1__.Common.setValidator("frv_ownedpercentage", isSharedOwnership);
        _common__WEBPACK_IMPORTED_MODULE_1__.Common.toggleVisibility("frv_whoisthehousingassociation", isSharedOwnership);
        _common__WEBPACK_IMPORTED_MODULE_1__.Common.setValidator("frv_whoisthehousingassociation", isSharedOwnership);
        this.setVisibilitiesPurchase();
        $("select").change(this.setVisibilitiesPurchase);
        const initialRequired = [
            "frv_buytolet",
            "frv_mortgagerequired",
            "frv_anyfactorsaffectingtransaction",
            "frv_confirmrelatedsale",
            "frv_isthereachain",
            "frv_anyfeespaidtoselleragent",
            "frv_propertyalteredsincefirstbuilt",
            "frv_agreedtopurchasemovableitems"
        ];
        initialRequired.forEach(selector => _common__WEBPACK_IMPORTED_MODULE_1__.Common.toggleVisibility(selector, true));
    }
    static setVisibilitiesPurchase() {
        const mortgageFields = [
            "frv_lenderknown",
            "frv_usingmortgagebroker",
            "frv_mortgagebrokername",
            "frv_mortgagebrokerphone",
            "frv_anypersonsnotonmortgage",
            "frv_lendername",
            "frv_detailsofpersonsnotonmortgage"
        ];
        const mortgage = $("#frv_mortgagerequired").val() === "100000001";
        mortgageFields.forEach(selector => _common__WEBPACK_IMPORTED_MODULE_1__.Common.toggleVisibility(selector, mortgage));
        _common__WEBPACK_IMPORTED_MODULE_1__.Common.toggleVisibility("frv_lendername", $("#frv_lenderknown").val() === "100000001" && mortgage);
        _common__WEBPACK_IMPORTED_MODULE_1__.Common.toggleVisibility("frv_mortgagebrokername", $("#frv_usingmortgagebroker").val() === "100000001" && mortgage);
        _common__WEBPACK_IMPORTED_MODULE_1__.Common.toggleVisibility("frv_mortgagebrokerphone", $("#frv_usingmortgagebroker").val() === "100000001" && mortgage);
        _common__WEBPACK_IMPORTED_MODULE_1__.Common.toggleVisibility("frv_detailsofpersonsnotonmortgage", $("#frv_anypersonsnotonmortgage").val() === "100000001" && mortgage);
        _common__WEBPACK_IMPORTED_MODULE_1__.Common.toggleVisibility("frv_affectingfactors", $("#frv_anyfactorsaffectingtransaction").val() === "100000001");
        _common__WEBPACK_IMPORTED_MODULE_1__.Common.toggleVisibility("frv_feedepositdetails", $("#frv_anyfeespaidtoselleragent").val() === "100000001");
        _common__WEBPACK_IMPORTED_MODULE_1__.Common.toggleVisibility("frv_propertyalterations", $("#frv_propertyalteredsincefirstbuilt").val() === "100000001");
        _common__WEBPACK_IMPORTED_MODULE_1__.Common.toggleVisibility("frv_itemandpaymentdetails", $("#frv_agreedtopurchasemovableitems").val() === "100000001");
        _common__WEBPACK_IMPORTED_MODULE_1__.Common.toggleVisibility("frv_transactionaddressandprice", $("#frv_confirmrelatedtransaction").val() === "100000001");
        _common__WEBPACK_IMPORTED_MODULE_1__.Common.toggleVisibility("frv_saleestateagentdetails", $("#frv_confirmrelatedtransaction").val() === "100000001");
    }
    static setupRemortgageQuestionnaire(isStaircasing) {
        _common__WEBPACK_IMPORTED_MODULE_1__.Common.toggleFieldsetVisibility("Shared Ownership", isStaircasing);
        _common__WEBPACK_IMPORTED_MODULE_1__.Common.toggleVisibility("frv_currentpercentage", isStaircasing);
        _common__WEBPACK_IMPORTED_MODULE_1__.Common.setValidator("frv_currentpercentage", isStaircasing);
        _common__WEBPACK_IMPORTED_MODULE_1__.Common.toggleVisibility("frv_newpercentage", isStaircasing);
        _common__WEBPACK_IMPORTED_MODULE_1__.Common.setValidator("frv_newpercentage", isStaircasing);
        _common__WEBPACK_IMPORTED_MODULE_1__.Common.toggleVisibility("frv_whoisthehousingassociation", isStaircasing);
        _common__WEBPACK_IMPORTED_MODULE_1__.Common.setValidator("frv_whoisthehousingassociation", isStaircasing);
        $("#frv_name").closest("td").hide();
        $("#frv_transaction").closest("td").hide();
        $("#frv_type").closest("td").hide();
        this.setVisibilitiesRemo();
        $("select").change(this.setVisibilitiesRemo);
        const initialRequired = [
            "frv_buytolet",
            "frv_newmortgageamount",
            "frv_mortgagevaluationreportrequested",
            "frv_currentlendername",
            "frv_accountnumber",
            "frv_newlendername",
            "frv_applicationmade",
            "frv_obtainedbuildinginsurancequote",
            "frv_anypersonsnotonmortgage",
            "frv_usingmortgagebroker",
            "frv_anyfactorsaffectingtransaction",
            "frv_confirmrelatedtransaction",
            "frv_desiredcompletiondateasap",
            "frv_amountowing",
            "frv_ercexists",
            "frv_mortgageaccountnumber"
        ];
        initialRequired.forEach(selector => _common__WEBPACK_IMPORTED_MODULE_1__.Common.toggleVisibility(selector, true));
        $("#frv_newmortgageamount").on('change', _common__WEBPACK_IMPORTED_MODULE_1__.Common.formatCurrency);
        $("#frv_newmortgageamount").trigger('change');
        $("#frv_amountowing").on('change', _common__WEBPACK_IMPORTED_MODULE_1__.Common.formatCurrency);
        $("#frv_amountowing").trigger('change');
    }
    static setVisibilitiesRemo() {
        _common__WEBPACK_IMPORTED_MODULE_1__.Common.toggleVisibility("frv_mortgagebrokername", $("#frv_usingmortgagebroker").val() === "100000001");
        _common__WEBPACK_IMPORTED_MODULE_1__.Common.toggleVisibility("frv_mortgagebrokerphone", $("#frv_usingmortgagebroker").val() === "100000001");
        _common__WEBPACK_IMPORTED_MODULE_1__.Common.toggleVisibility("frv_brokerdiscussionconsent", $("#frv_usingmortgagebroker").val() === "100000001");
        _common__WEBPACK_IMPORTED_MODULE_1__.Common.toggleVisibility("frv_detailsofpersonsnotonmortgage", $("#frv_anypersonsnotonmortgage").val() === "100000001");
        _common__WEBPACK_IMPORTED_MODULE_1__.Common.toggleVisibility("frv_affectingfactors", $("#frv_anyfactorsaffectingtransaction").val() === "100000001");
        _common__WEBPACK_IMPORTED_MODULE_1__.Common.toggleVisibility("frv_propertyalterations", $("#frv_propertyalteredsincefirstbuilt").val() === "100000001");
        _common__WEBPACK_IMPORTED_MODULE_1__.Common.toggleVisibility("frv_transactionaddressandprice", $("#frv_confirmrelatedtransaction").val() === "100000001");
        _common__WEBPACK_IMPORTED_MODULE_1__.Common.toggleVisibility("frv_desiredcompletiondate", $("#frv_desiredcompletiondateasap").val() === "100000000");
        _common__WEBPACK_IMPORTED_MODULE_1__.Common.toggleVisibility("frv_ercexpiration", $("#frv_ercexists").val() === "100000000");
    }
}


/***/ }),

/***/ "./src/stripe.ts":
/*!***********************!*\
  !*** ./src/stripe.ts ***!
  \***********************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   StripeHandler: () => (/* binding */ StripeHandler)
/* harmony export */ });
/* harmony import */ var _common__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./common */ "./src/common.ts");
var __awaiter = (undefined && undefined.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};

class StripeHandler {
    static initializeStripe() {
        return __awaiter(this, void 0, void 0, function* () {
            const blockPerfTracker = ClientLogWrapper.getLogger().getBlockPerfTracker();
            try {
                blockPerfTracker.start("RenderPaymentElements", "Payment_Provider");
                const appearance = {
                    theme: 'stripe',
                    rules: {
                        '.Tab': {
                            backgroundColor: StripeHandler.getCssPropertyValueFromVariable('--portalThemeColor7'),
                            color: StripeHandler.getCssPropertyValueFromVariable('--portalThemeOnColor7')
                        },
                        '.Tab:hover': {
                            backgroundColor: StripeHandler.getCssPropertyValueFromVariable('--portalThemeColor7'),
                            color: StripeHandler.getCssPropertyValueFromVariable('--portalThemeOnColor7')
                        },
                        '.Tab:focus': {
                            backgroundColor: StripeHandler.getCssPropertyValueFromVariable('--portalThemeColor7'),
                            color: StripeHandler.getCssPropertyValueFromVariable('--portalThemeOnColor7')
                        },
                        '.Tab:active': {
                            backgroundColor: StripeHandler.getCssPropertyValueFromVariable('--portalThemeColor7'),
                            color: StripeHandler.getCssPropertyValueFromVariable('--portalThemeOnColor7')
                        },
                        '.Tab--selected': {
                            border: '1px solid #2f5fef',
                            boxShadow: 'none'
                        },
                        '.Tab--selected:hover': {
                            border: '1px solid #2f5fef',
                            boxShadow: 'none'
                        },
                        '.Tab--selected:focus': {
                            border: '1px solid #2f5fef',
                            boxShadow: 'none'
                        },
                        '.Tab--selected:active': {
                            border: '1px solid #2f5fef',
                            boxShadow: 'none'
                        },
                        '.Input': {
                            border: '1px solid var(--colorText)',
                            borderRadius: 0,
                            fontSize: '15px'
                        },
                        '.Input:focus': {
                            border: '1px solid #114975',
                            boxShadow: 'inset 0 1px 1px rgba(0, 0, 0, .075), 0 0 8px rgba(17, 73, 117, .6)',
                            fontSize: '15px'
                        },
                        '.Label': {
                            display: 'inline-block',
                            maxWidth: '100%',
                            marginBottom: '5px',
                            fontWeight: 'bold',
                            color: StripeHandler.getCssPropertyValueFromVariable("--portalThemeColor8")
                        },
                        '.SecondaryLink:focus': {
                            outline: '1px solid #484848',
                            boxShadow: 'inset 0 1px 1px rgba(0, 0, 0, .075), 0 0 8px rgba(72, 72, 72, .6)',
                            fontSize: '15px'
                        },
                        '.Link:focus': {
                            outline: '1px solid #484848',
                            boxShadow: 'inset 0 1px 1px rgba(0, 0, 0, .075), 0 0 8px rgba(72, 72, 72, .6)',
                            fontSize: '15px'
                        },
                    },
                    variables: {
                        colorPrimary: StripeHandler.getCssPropertyValueFromVariable("--portalThemeColor8"),
                        colorBackground: StripeHandler.getCssPropertyValueFromVariable('--portalThemeColor7'),
                        colorPrimaryText: StripeHandler.getCssPropertyValueFromVariable("--portalThemeOnColor7"),
                        colorBackgroundText: StripeHandler.getCssPropertyValueFromVariable('--portalThemeOnColor7'),
                        colorText: StripeHandler.getCssPropertyValueFromVariable('--portalThemeOnColor7'),
                        colorTextSecondary: StripeHandler.getCssPropertyValueFromVariable('--portalThemeOnColor7'),
                        colorDanger: '#A80000',
                        borderRadius: '2px',
                        fontFamily: '"Segoe UI", "Helvetica Neue", Helvetica, Arial, sans-serif',
                        fontSizeSm: '15px',
                        fontSizeXs: '14px'
                    }
                };
                const response = yield shell.ajaxSafePost({
                    contentType: "application/json",
                    type: "POST",
                    url: '/_api/cloudflow/v1.0/trigger/fd7f2b02-0366-ef11-a670-0022481b5955', // Create Payment Intent
                    data: JSON.stringify({
                        "eventData": JSON.stringify({
                            "ContactId": StripeHandler.contactId,
                            "RegardingId": $("#EntityFormView_EntityID").val(),
                            "RegardingName": $("#EntityFormView_EntityName").val(),
                            "Amount": StripeHandler.amount
                        })
                    }),
                    processData: false,
                    global: false
                });
                const data = yield JSON.parse(response);
                const clientSecret = data.client_secret;
                StripeHandler.stripe = Stripe(data.stripe_secret);
                // Initialize Stripe elements
                StripeHandler.elements = StripeHandler.stripe.elements({ appearance, clientSecret });
                const paymentElementOptions = { layout: "tabs" };
                const paymentElement = StripeHandler.elements.create("payment", paymentElementOptions);
                // Mount the payment element
                paymentElement.mount("#payment-element");
                $("#payment-element").css({ maxWidth: '486px', padding: '0 28px 20px' });
            }
            finally {
                blockPerfTracker.stop();
                $("#overlay-full").fadeOut(300);
            }
        });
    }
    static waitForPaymentIntentConfirmation(paymentIntentId) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield _common__WEBPACK_IMPORTED_MODULE_0__.Common.safeAjax({
                type: "GET",
                url: `/_api/frv_payments?$count=true&$select=frv_paymentid,frv_amount,frv_reference&$filter=createdon ne '${new Date().toISOString()}' and statuscode eq 100000002 and frv_reference eq %27${paymentIntentId}%27`,
                contentType: "application/json",
            });
            if (result["@odata.count"] === 0) {
                yield new Promise(resolve => setTimeout(resolve, 1000));
                yield StripeHandler.waitForPaymentIntentConfirmation(paymentIntentId);
            }
        });
    }
    static waitForSetupIntentConfirmation(setupIntentId) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield _common__WEBPACK_IMPORTED_MODULE_0__.Common.safeAjax({
                type: "GET",
                url: `/_api/frv_contacttransactions?$count=true&$select=frv_contacttransactionid&$filter=createdon ne '${new Date().toISOString()}' and frv_subscriptionexpirydate ge ${new Date().toISOString().split('T')[0]} and frv_contacttransactionid eq %27${$("#EntityFormView_EntityID").val()}%27`,
                contentType: "application/json",
            });
            if (result["@odata.count"] === 0) {
                yield new Promise(resolve => setTimeout(resolve, 1000));
                yield StripeHandler.waitForSetupIntentConfirmation(setupIntentId);
            }
        });
    }
    static handleStripePayment() {
        return __awaiter(this, void 0, void 0, function* () {
            $("#PaymentMessageSummary").remove();
            StripeHandler.setLoading(true);
            const buttonName = $("#PaymentButton").attr('name');
            const event = window.event;
            if (typeof (webFormClientValidate) !== 'undefined' && !webFormClientValidate()) {
                StripeHandler.setLoading(false);
                return;
            }
            else {
                $('#ValidationSummaryEntityFormControl_EntityFormView').remove();
            }
            try {
                const blockPerfTracker = ClientLogWrapper.getLogger().getBlockPerfTracker();
                blockPerfTracker.start("HandleStripePayment", "Payment_Provider");
                let error = null;
                let setupIntent = null;
                let paymentIntent = null;
                if (StripeHandler.amount === 0) {
                    ({ error, setupIntent } = yield StripeHandler.stripe.confirmSetup({
                        elements: StripeHandler.elements,
                        confirmParams: {
                            return_url: window.location.href
                        },
                        redirect: 'if_required'
                    }));
                }
                else {
                    ({ error, paymentIntent } = yield StripeHandler.stripe.confirmPayment({
                        elements: StripeHandler.elements,
                        confirmParams: {
                            return_url: window.location.href
                        },
                        redirect: 'if_required'
                    }));
                }
                if (error) {
                    ClientLogWrapper.getLogger().traceError("Stripe Payment Failed- " + error.message, "Payment_Provider");
                    StripeHandler.setLoading(false);
                    $('div.payment-elements').after(`<div id="PaymentMessageSummary" class="validation-summary alert alert-error alert-danger alert-block" tabindex="0">
                    <span aria-hidden="true" style="vertical-align: middle;"></span> <span aria-label="Message Summary">${error.message}</span></div>`);
                }
                else if (paymentIntent) {
                    window.event = event;
                    let message = '';
                    if (paymentIntent.status === "succeeded") {
                        yield StripeHandler.waitForPaymentIntentConfirmation(paymentIntent.id);
                        message = 'Successful Payment';
                        ClientLogWrapper.getLogger().traceInfo("Stripe Payment Succeeded", "Payment_Provider");
                    }
                    StripeHandler.initPaymentStep(StripeHandler.contactId, StripeHandler.amount.toString());
                }
                else if (setupIntent) {
                    window.event = event;
                    let message = '';
                    if (setupIntent.status === "succeeded") {
                        yield StripeHandler.waitForSetupIntentConfirmation(setupIntent.id);
                        message = 'Successfully Subscribed';
                        ClientLogWrapper.getLogger().traceInfo("Stripe Subscription Succeeded", "Payment_Provider");
                    }
                    StripeHandler.initPaymentStep(StripeHandler.contactId, StripeHandler.amount.toString());
                }
            }
            catch (error) {
                StripeHandler.setLoading(false);
                $('div.payment-elements').after(`<div id="PaymentMessageSummary" class="validation-summary alert alert-error alert-danger alert-block" tabindex="0">
                <span aria-hidden="true" style="vertical-align: middle;"></span> <span aria-label="Message Summary">${error.message}</span></div>`);
            }
            finally {
                const blockPerfTracker = ClientLogWrapper.getLogger().getBlockPerfTracker();
                blockPerfTracker.stop();
            }
        });
    }
    static setLoading(isLoading) {
        const inputs = document.getElementsByTagName("input");
        for (let i = 0; i < inputs.length; i++) {
            if (inputs[i].type === 'submit' || inputs[i].type === 'button') {
                inputs[i].disabled = isLoading;
            }
        }
        if (isLoading) {
            $("#PaymentButton").val('Processing...');
        }
        else {
            $("#PaymentButton").val(StripeHandler.buttonText);
        }
    }
    static getCssPropertyValueFromVariable(variableName) {
        const computedStyles = getComputedStyle(StripeHandler.rootCss);
        return computedStyles.getPropertyValue(variableName);
    }
    static initPaymentStep(contactId = "", amount = "") {
        StripeHandler.amount = Number(amount.replace('£', '').replace(/,/g, '')) * 100;
        StripeHandler.contactId = contactId;
        $("#overlay-full").fadeOut(300);
        $('.actions').hide();
        $("#liquid_form").prepend(`<div id="overlay-full">
          <div class="cv-spinner">
            <span class="spinner-big"></span>
          </div>
        </div>`);
        $("#overlay-full").fadeIn(300);
        let url = `/_api/frv_payments?$select=frv_reference&$count=true&$filter=createdon ne '${new Date().toISOString()}' and statuscode eq 100000002 and _frv_regardingid_value eq %27${$("#EntityFormView_EntityID").val()}%27`;
        if (StripeHandler.amount === 0) {
            StripeHandler.buttonText = "Activate Subscription";
            url = `/_api/frv_contacttransactions?$count=true&$select=frv_subscriptionreference&$filter=createdon ne '${new Date().toISOString()}' and frv_subscriptionexpirydate ge ${new Date().toISOString().split('T')[0]} and frv_contacttransactionid eq %27${$("#EntityFormView_EntityID").val()}%27`;
        }
        _common__WEBPACK_IMPORTED_MODULE_0__.Common.safeAjax({
            type: "GET",
            url: url,
            contentType: "application/json",
            success: (result) => {
                if (result["@odata.count"] === 0) {
                    $('#EntityFormView fieldset').append(`<div class="payment-elements"><div id="payment-element" class="StripeElement" style="max-width: 486px; padding: 0px 28px 20px;">
                        <div class="__PrivateStripeElement" style="margin: -4px 0px !important; padding: 0px !important; border: none !important; display: block !important; background: transparent !important; position: relative !important; opacity: 1 !important; clear: both !important; transition: height 0.35s ease 0s !important;">
                        <iframe name="__privateStripeFrame7754" frameborder="0" allowtransparency="true" scrolling="no" role="presentation" allow="payment *; publickey-credentials-get *" src="https://js.stripe.com/v3/elements-inner-payment-0a042e09264075da02f6c1dbbefd3e75.html#wait=false&amp;rtl=false&amp;publicOptions[layout]=tabs&amp;componentName=payment&amp;keyMode=test&amp;apiKey=pk_test_51P45b3GqOTpNsIhpixxiO9ug5fEoQ5zlZlo3kQYlNVNU0jQOPJQ0nG0kaqWGnoqbv9VqSQv8ocVfXjSp8OLmr6qH00x3fqSyNK&amp;referrer=https%3A%2F%2Fconsumerhub.powerappsportals.com%2FSale%2F%3FtransactionId%3D207751f8-8447-46e3-a4f8-0a6ffbe286cd%26stepid%3D0dcc2e39-3d36-ef11-a317-002248c6891d&amp;controllerId=__privateStripeController7751" title="Secure payment input frame" style="border: 0px !important; margin: -4px; padding: 0px !important; width: calc(100% + 8px); min-width: 100% !important; overflow: hidden !important; display: block !important; user-select: none !important; transform: translate(0px) !important; color-scheme: light only !important; height: 303.391px; opacity: 1; transition: height 0.35s ease 0s, opacity 0.4s ease 0.1s;"></iframe></div></div></div>
                        <div id="stripe-actions" class="actions"><div class="col-md-6 clearfix"><div role="group" class="btn-group entity-action-button"><input type="button" name="ctl00$ContentContainer$WebFormControl_ffd1cc0ad924ef11840b002248c6891d$PaymentButton" value="${StripeHandler.buttonText}" onclick="javascript:var paymentPromise = StripeHandler.handleStripePayment(); return false;WebForm_DoPostBackWithOptions(new WebForm_PostBackOptions(&quot;ctl00$ContentContainer$WebFormControl_ffd1cc0ad924ef11840b002248c6891d$PaymentButton&quot;, &quot;&quot;, true, &quot;&quot;, &quot;&quot;, false, true))" id="PaymentButton" class="btn btn-primary button next submit-btn" nonactionlinkbutton="true"></div></div></div>`);
                    StripeHandler.initializeStripe();
                }
                else {
                    var message = `You have successfully subscribed for the Property Alert Protect service! Payment will be taken in 1 year and your home will continue to benefit from this protection.`;
                    if (StripeHandler.amount > 0) {
                        message = `Thank you for paying your monies on account to Kingsley Bond. Your payment was successful and your payment reference is: ${result.value[0]["frv_reference"]}`;
                    }
                    $('#EntityFormView').after(`<div id="PaymentMessageSummary" class="validation-summary alert alert-success alert-block" tabindex="0"><span aria-hidden="true" style="vertical-align: middle;"></span> <span aria-label="Message Summary">${message}</span></div>`);
                    $('#EntityFormView').hide();
                    $('.actions').show();
                    $("#NextButton").prop('disabled', false);
                    $("#overlay-full").fadeOut(300);
                }
            }
        });
    }
}
StripeHandler.rootCss = document.querySelector(':root');
StripeHandler.buttonText = "Pay Now";
StripeHandler.amount = 0.0;
StripeHandler.contactId = "";


/***/ }),

/***/ "./src/yoti.ts":
/*!*********************!*\
  !*** ./src/yoti.ts ***!
  \*********************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   Yoti: () => (/* binding */ Yoti)
/* harmony export */ });
/* harmony import */ var _common__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./common */ "./src/common.ts");
var __awaiter = (undefined && undefined.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};

class Yoti {
    static loadYotiSignFrame(transactionId_1, contactTransactionId_1, documentName_1) {
        return __awaiter(this, arguments, void 0, function* (transactionId, contactTransactionId, documentName, multiClient = false) {
            $('.actions').hide();
            $("#liquid_form").prepend(`<div id="overlay-full">
          <div class="cv-spinner">
            <span class="spinner-big"></span>
          </div>
        </div>`);
            $("#overlay-full").fadeIn(300);
            const response = yield shell.ajaxSafePost({
                contentType: "application/json",
                type: "POST",
                url: '/_api/cloudflow/v1.0/trigger/f5e78c2b-d59d-ef11-8a69-000d3a0ce486', // Get Signing Document
                processData: false,
                data: JSON.stringify({
                    "eventData": JSON.stringify({
                        "ContactTransactionId": contactTransactionId,
                        "DocumentName": documentName,
                        "MultiClient": multiClient
                    })
                }),
                global: false
            });
            const data = JSON.parse(response);
            const url = data.url;
            const primaryContact = data.primarycontact === "True";
            const leadSigned = data.leadsigned === "True";
            Yoti.envelopeId = data.envelopeid;
            const token = data.token;
            if (multiClient && !leadSigned && !primaryContact) {
                $('#EntityFormView fieldset').hide();
                $("#overlay-full").fadeOut(300);
                _common__WEBPACK_IMPORTED_MODULE_0__.Common.showMessage(`Lead client has not signed yet, please try again later.`, "warning", false);
                $("#ValidationSummaryEntityFormControl_EntityFormView").after(`<button type="button" style='float:right;padding:10px;margin-top: -10px;' 
                onClick="window.location.href = '/'">Back To Activity Hub</button>`);
            }
            else {
                $('#EntityFormView fieldset').append(`<iframe id="yotiFrame" src="${url}/embedded/sign/${token}" 
            allowfullscreen style = "height:605px; width:100%; border:none;"  frameborder = "0" scrolling = "no" /> `);
                $("#overlay-full").fadeOut(300);
                setTimeout(Yoti.documentSignedMoveNext.bind(null, contactTransactionId, "frv_" + documentName.replace(/ /g, '').replace('-', '').toLowerCase() + "signed"), 5000);
            }
        });
    }
    static documentSignedMoveNext(contactTransactionId, signedField) {
        _common__WEBPACK_IMPORTED_MODULE_0__.Common.safeAjax({
            type: "GET",
            url: `/_api/frv_contacttransactions(${contactTransactionId})?$select=${signedField}
                &$filter=createdon ne '${new Date().toISOString()}'`,
            contentType: "application/json",
            success: (result) => {
                if (result[signedField]) {
                    $("#overlay-full").fadeIn(300);
                    $("#NextButton").click();
                }
                else {
                    setTimeout(Yoti.documentSignedMoveNext.bind(null, contactTransactionId, signedField), 1000);
                }
            }
        });
    }
    static loadYotiVerifyFrame(contactId, yotiSessionId, yotiSessionToken) {
        $('#EntityFormView').after(`<iframe id="yotiFrame" src="https://api.yoti.com/idverify/v1/web/index.html" style="height:605px; width:100%; border:none;" allow="camera"></iframe>`);
        const yotiFrame = $("#yotiFrame")[0].contentWindow;
        const origin = 'https://api.yoti.com';
        window.addEventListener('message', event => {
            if (event.origin === origin) {
                if (event.data.eventType === 'STARTED') {
                    yotiFrame.postMessage({
                        eventType: 'INIT_SESSION',
                        sessionID: yotiSessionId,
                        sessionToken: yotiSessionToken,
                    }, origin);
                    $("#overlay-full").fadeOut(300);
                }
                else if (event.data.eventType === 'SUCCESS') {
                    $("#liquid_form").prepend(`<div id="overlay-full">
                          <div class="cv-spinner">
                            <span class="spinner-big"></span>
                          </div>
                        </div>`);
                    $("#overlay-full").fadeIn(300);
                    Yoti.checkYotiVerifyResult(contactId);
                }
                else {
                    _common__WEBPACK_IMPORTED_MODULE_0__.Common.showMessage("Identify Verification Failed. Please try again. <button style='float:right' onClick='window.location.reload();'>Try Again</button>", "danger");
                }
            }
        });
    }
    static startNewYotiVerifySession(contactId, contactTransactionId) {
        $('.actions').hide();
        $("#liquid_form").prepend(`<div id="overlay-full">
          <div class="cv-spinner">
            <span class="spinner-big"></span>
          </div>
        </div>`);
        $("#overlay-full").fadeIn(300);
        shell.ajaxSafePost({
            contentType: "application/json",
            type: "POST",
            url: '/_api/cloudflow/v1.0/trigger/6ad3f36e-d649-ef11-a316-0022481b4bf1',
            data: JSON.stringify({ "eventData": JSON.stringify({ "ContactTransactionId": contactTransactionId }) }),
            processData: false,
            global: false
        })
            .done((response) => {
            const data = JSON.parse(response);
            _common__WEBPACK_IMPORTED_MODULE_0__.Common.safeAjax({
                type: "PUT",
                url: `/_api/contacts(${contactId})/frv_yotisessionid`,
                contentType: "application/json",
                data: JSON.stringify({ "value": data.sessionid }),
                success: (res) => {
                    Yoti.loadYotiVerifyFrame(contactId, data.sessionid, data.clientsessiontoken);
                }
            });
        });
    }
    static checkYotiVerifyResult(contactId) {
        _common__WEBPACK_IMPORTED_MODULE_0__.Common.safeAjax({
            type: "GET",
            url: `/_api/contacts(${contactId})?$select=frv_yotiidentityvalid&$filter=createdon ne '${new Date().toISOString()}'`,
            contentType: "application/json",
            success: (result) => {
                if (result["frv_yotiidentityvalid"]) {
                    $("#overlay-full").fadeIn(300);
                    $("#NextButton").click();
                }
                else {
                    setTimeout(() => Yoti.checkYotiVerifyResult(contactId), 1000);
                }
            }
        });
    }
}
Yoti.canNext = false;
Yoti.envelopeId = "";


/***/ })

/******/ 	});
/************************************************************************/
/******/ 	// The module cache
/******/ 	var __webpack_module_cache__ = {};
/******/ 	
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/ 		// Check if module is in cache
/******/ 		var cachedModule = __webpack_module_cache__[moduleId];
/******/ 		if (cachedModule !== undefined) {
/******/ 			return cachedModule.exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = __webpack_module_cache__[moduleId] = {
/******/ 			// no module.id needed
/******/ 			// no module.loaded needed
/******/ 			exports: {}
/******/ 		};
/******/ 	
/******/ 		// Execute the module function
/******/ 		__webpack_modules__[moduleId](module, module.exports, __webpack_require__);
/******/ 	
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/ 	
/************************************************************************/
/******/ 	/* webpack/runtime/define property getters */
/******/ 	(() => {
/******/ 		// define getter functions for harmony exports
/******/ 		__webpack_require__.d = (exports, definition) => {
/******/ 			for(var key in definition) {
/******/ 				if(__webpack_require__.o(definition, key) && !__webpack_require__.o(exports, key)) {
/******/ 					Object.defineProperty(exports, key, { enumerable: true, get: definition[key] });
/******/ 				}
/******/ 			}
/******/ 		};
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/hasOwnProperty shorthand */
/******/ 	(() => {
/******/ 		__webpack_require__.o = (obj, prop) => (Object.prototype.hasOwnProperty.call(obj, prop))
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/make namespace object */
/******/ 	(() => {
/******/ 		// define __esModule on exports
/******/ 		__webpack_require__.r = (exports) => {
/******/ 			if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 				Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 			}
/******/ 			Object.defineProperty(exports, '__esModule', { value: true });
/******/ 		};
/******/ 	})();
/******/ 	
/************************************************************************/
var __webpack_exports__ = {};
// This entry need to be wrapped in an IIFE because it need to be isolated against other modules in the chunk.
(() => {
/*!**********************!*\
  !*** ./src/index.ts ***!
  \**********************/
__webpack_require__.r(__webpack_exports__);
/* harmony import */ var _yoti__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./yoti */ "./src/yoti.ts");
/* harmony import */ var _address__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./address */ "./src/address.ts");
/* harmony import */ var _stripe__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./stripe */ "./src/stripe.ts");
/* harmony import */ var _common__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./common */ "./src/common.ts");
/* harmony import */ var _estimate__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ./estimate */ "./src/estimate.ts");
/* harmony import */ var _contact__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ./contact */ "./src/contact.ts");
/* harmony import */ var _lead__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ./lead */ "./src/lead.ts");
/* harmony import */ var _administration__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! ./administration */ "./src/administration.ts");
/* harmony import */ var _dashboard__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! ./dashboard */ "./src/dashboard.ts");
/* harmony import */ var _questionnaire__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(/*! ./questionnaire */ "./src/questionnaire.ts");
/* harmony import */ var _message__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(/*! ./message */ "./src/message.ts");











window.Yoti = _yoti__WEBPACK_IMPORTED_MODULE_0__.Yoti;
window.Address = _address__WEBPACK_IMPORTED_MODULE_1__.Address;
window.StripeHandler = _stripe__WEBPACK_IMPORTED_MODULE_2__.StripeHandler;
window.Common = _common__WEBPACK_IMPORTED_MODULE_3__.Common;
window.Estimate = _estimate__WEBPACK_IMPORTED_MODULE_4__.Estimate;
window.Contact = _contact__WEBPACK_IMPORTED_MODULE_5__.Contact;
window.Lead = _lead__WEBPACK_IMPORTED_MODULE_6__.Lead;
window.Administration = _administration__WEBPACK_IMPORTED_MODULE_7__.Administration;
window.Dashboard = _dashboard__WEBPACK_IMPORTED_MODULE_8__.Dashboard;
window.Questionnaire = _questionnaire__WEBPACK_IMPORTED_MODULE_9__.Questionnaire;
window.Message = _message__WEBPACK_IMPORTED_MODULE_10__.Message;

})();

/******/ })()
;